"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreTelAPI = void 0;
const APIBase_1 = require("./APIBase");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
var request = require('request');
var convert = require('xml-js');
class CoreTelAPI extends APIBase_1.APIBase {
    key;
    secret;
    priority;
    account;
    constructor(proirity, account) {
        super();
        this.key = "signalmash.com_did";
        this.secret = "092klqoz,s8";
        this.priority = proirity;
        this.account = account;
    }
    getNpaNxx(req, res, callback) {
        if (this.priority = "100") {
            return;
        }
        else {
            const npa = req.query.NPA;
            let nxx = "";
            if (req.body.NXX != undefined)
                nxx = req.query.NXX;
            const rate_center = req.query.RateCenter;
            const qty = req.query.Qty;
            let options = {
                'method': 'POST',
                'url': 'https://numberdb.coretel.net/cgi-bin/xmlnumberdb.pl',
                'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>VanitySearch</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><NPA>" + npa + "</NPA><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
                rejectUnauthorized: false,
                requestCert: true,
                agent: false
            };
            console.log("options", options);
            request(options, (error, response, body) => {
                if (!error) {
                    let tmp = body;
                    let valid_xml = tmp.slice(0, -6);
                    console.log(valid_xml);
                    var result1 = convert.xml2json(valid_xml, { compact: true, spaces: 4 });
                    var res1 = JSON.parse(result1);
                    let ddata = res1.xml.SearchResult;
                    console.log("Data==>", ddata);
                    if (ddata !== undefined && ddata.length > 0) {
                        let str = ddata;
                        let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`) VALUE ";
                        str.forEach((ele) => {
                            console.log(ele.Number._text);
                            qrystr += "('','" + ele.Number._text + "', '', '', '" + ele.RateCenter._text + "', '', '', '', '' ,'" + "coreTel" + "', '" + this.account + "', '" + this.priority + "'),";
                        });
                        obj1.nonqrysql = qrystr.slice(0, -1);
                        obj1.prepare();
                        obj1.execute((err, data) => {
                            callback(err, data);
                        });
                    }
                    else {
                        callback('', ddata);
                    }
                }
                else {
                    callback('', error);
                }
            });
        }
    }
    getByRate(req, res, callback) {
        if (this.priority = "100") {
            return;
        }
        else {
            const state = req.query.State;
            const rate_center = req.query.RateCenter;
            const qty = req.query.Qty;
            let options = {
                'method': 'POST',
                'url': 'https://devapi.coretel.net/cgi-bin/xmlnumberdb.pl',
                'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>VanitySearch</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><State>" + state + "</State><RateCenter>" + rate_center + "</RateCenter><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
                rejectUnauthorized: false,
                requestCert: true,
                agent: false
            };
            request(options, (error, response, body) => {
                if (!error) {
                    let tmp = body;
                    let valid_xml = tmp.slice(0, -6);
                    console.log(valid_xml);
                    var result1 = convert.xml2json(valid_xml, { compact: true, spaces: 4 });
                    var res1 = JSON.parse(result1);
                    let ddata = res1.xml.SearchResult;
                    console.log("Data==>", ddata);
                    if (ddata !== undefined && ddata.length > 0) {
                        let str = ddata;
                        let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`) VALUE ";
                        str.forEach((ele) => {
                            console.log(ele.Number._text);
                            qrystr += "('','" + ele.Number._text + "', '', '', '" + ele.RateCenter._text + "', '', '', '', '' ,'" + "coreTel" + "', '" + this.account + "', '" + this.priority + "'),";
                        });
                        obj1.nonqrysql = qrystr.slice(0, -1);
                        obj1.prepare();
                        obj1.execute((err, data) => {
                            callback(err, data);
                        });
                    }
                    else {
                        callback('', ddata);
                    }
                }
                else {
                    callback('', error);
                }
            });
        }
    }
    getTollFree(req, res, callback) {
        if (this.priority == "100") {
            return;
        }
        else {
            const tollfree = req.query.TF_PREFIX;
            const qty = req.query.Qty;
            let options = {
                'method': 'POST',
                'url': 'https://devapi.coretel.net/cgi-bin/xmlnumberdb.pl',
                'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>VanitySearch</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><Tollfree>" + tollfree + "</Tollfree><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
                rejectUnauthorized: false,
                requestCert: true,
                agent: false
            };
            request(options, (error, response, body) => {
                if (!error) {
                    let tmp = body;
                    let valid_xml = tmp.slice(0, -6);
                    console.log(valid_xml);
                    var result1 = convert.xml2json(valid_xml, { compact: true, spaces: 4 });
                    var res1 = JSON.parse(result1);
                    let ddata = res1.xml.SearchResult;
                    console.log("Data==>", ddata);
                    if (ddata !== undefined && ddata.length > 0) {
                        let str = ddata;
                        let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`) VALUE ";
                        str.forEach((ele) => {
                            console.log(ele.Number._text);
                            qrystr += "('','" + ele.Number._text + "', '', '', '" + ele.RateCenter._text + "', '', '', '', '' ,'" + "coreTel" + "', '" + this.account + "', '" + this.priority + "'),";
                        });
                        obj1.nonqrysql = qrystr.slice(0, -1);
                        obj1.prepare();
                        obj1.execute((err, data) => {
                            callback(err, data);
                        });
                    }
                    else {
                        callback('', ddata);
                    }
                }
                else {
                    callback('', error);
                }
            });
        }
    }
    buyDID(req, res, callback) {
        const sdata = req.body;
        const qty = sdata.Qty;
        const did = sdata.DID;
        let options = {
            'method': 'POST',
            'url': 'https://numberdb.coretel.net/cgi-bin/xmlnumberdb.pl',
            'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>BlockRequest</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><DID>" + did + "</DID><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
            rejectUnauthorized: false,
            requestCert: true,
            agent: false
        };
        request(options, (error, response) => {
            if (error) {
                console.log("error", error);
            }
            else {
                console.log("response", response);
            }
        });
    }
    disconnectDID(req, res, callback) {
        let options = {
            'method': 'POST',
            'url': 'https://devapi.coretel.net/cgi-bin/xmlnumberdb.pl',
            'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>BlockRequest</RequestType><Purpose>$xmlpurpose</Purpose><Quantity>$xmlqty</Quantity><Email>$xmlemail</Email><RateCenterAbbrev>$xmlrate_center_abbrev</RateCenterAbbrev><RateCenter>$xmlrate_center</RateCenter><NPA>$xmlnpa</NPA><SIP_MS_IP>$xmlgw_ip</SIP_MS_IP><SIP_Port>$xmlsip_port</SIP_Port><BillingAccount>$xmlaccount</BillingAccount><Password>$xmlpassword</Password><ForwardTo>$xmlfwdto</ForwardTo><RouteToURI>$xmlroute_to_uri</RouteToURI><SIP_URI>$xmlsip_uri</SIP_URI><EUPassword>$xmleupass</EUPassword><AdminPassword>$xmladminpass</AdminPassword><Expires>$xmlexpires</Expires><Duration>$xmlduration</Duration></xml>",
            rejectUnauthorized: false,
            requestCert: true,
            agent: false
        };
        request(options, (error, response, body) => {
            if (!error) {
                let tmp = body;
                let valid_xml = tmp.slice(0, -6);
                console.log(valid_xml);
                var result1 = convert.xml2json(valid_xml, { compact: true, spaces: 4 });
                var res1 = JSON.parse(result1);
                let ddata = res1.xml.SearchResult;
                console.log("Data==>", ddata);
                if (ddata !== undefined && ddata.length > 0) {
                    let str = ddata;
                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`) VALUE ";
                    str.forEach((ele) => {
                        console.log(ele.Number._text);
                        qrystr += "('','" + ele.Number._text + "', '', '', '" + ele.RateCenter._text + "', '', '', '', '' ,'" + "coreTel" + "', '" + this.account + "', '" + this.priority + "'),";
                    });
                    obj1.nonqrysql = qrystr.slice(0, -1);
                    obj1.prepare();
                    obj1.execute((err, data) => {
                        callback(err, data);
                    });
                }
                else {
                    callback('', ddata);
                }
            }
            else {
                callback('', error);
            }
        });
    }
    MakeCall(req, res, next) { }
    MakeOutboundCallToNumber(req, res, next) { }
    /**
     * For bulk DID purchase callback method
     */
    buyDID_CB(req, res, DID, callback) {
        const sdata = req.body;
        const qty = sdata.Qty;
        const did = DID;
        let options = {
            'method': 'POST',
            'url': 'https://numberdb.coretel.net/cgi-bin/xmlnumberdb.pl',
            'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>BlockRequest</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><DID>" + did + "</DID><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
            rejectUnauthorized: false,
            requestCert: true,
            agent: false
        };
        request(options, (error, response) => {
            if (!error) {
                callback("", { error: 0, status: 200, message: "DID buy successfully" });
            }
            else {
                callback(error, { error: 1, status: 404, message: error });
            }
        });
    }
}
exports.CoreTelAPI = CoreTelAPI;
