"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SinchApi = void 0;
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const sinchNumberRegistry_1 = require("../include/sinchNumberRegistry");
const RawView_1 = require("../lib/view/RawView");
let request = require('request');
const produrl = 'http://65.214.42.91:84/osr/v2/entries/';
const projectId = "bd6ca3f8-040c-4b40-ba6c-09f8d63be111";
const servicePlanId = "IP_LINK_RA";
const userId = "f0c489dd-2203-4dc9-964a-c59021b9ee74";
const passwd = "Ew6Ynk~ddXD2UqmoHxWywDczB_";
const myip = "iplink";
const nnid = "104141";
class SinchApi extends sinchNumberRegistry_1.SinchNumberRegistry {
    constructor(proirity, sessdata) {
        super(proirity, sessdata);
    }
    /* <===  Osr Update Or Add Osr Entry Type1 ==> */
    submitNumber(req, res, callback) {
        let sdata = req.body;
        let did = sdata.DID;
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "+1" + number;
        var headers = {
            'accept': '*/*',
            'Accept': 'application/json'
        };
        var dataString = '{"phone_number":' + number1 + ', "projectId":' + projectId + ', "region_code":"US", "smsConfiguration":{"servicePlanId":' + servicePlanId + ', "campaignId":' + sdata.CampaignId + '}}';
        var options = {
            url: 'https://imported.numbers.api.sinch.com/v1beta1/projects/' + projectId + '/importedNumbers',
            method: 'POST',
            headers: headers,
            body: dataString,
            auth: {
                'user': userId,
                'pass': passwd
            }
        };
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                if (data.status == "WAITING") {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE `did_buy` SET `sinch_status` = 'register' where `iduser` = '" + this.sessdata.iduser + "' AND `did`='" + number + "'";
                    obj.prepare();
                    obj.execute((err, resp) => {
                        if (resp) {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({});
                            obj.execute();
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ "error": "Query Error", "err": err });
                            obj.execute();
                        }
                    });
                }
                else if (data.status == "FAILED") {
                    this.updateNumber(req, res, (err, res) => {
                        if (res) {
                        }
                        else {
                        }
                    });
                }
            }
            else {
                callback(error, "");
            }
        });
    }
    /* <===  Osr Update Entry Type2 ==> */
    updateNumber(req, res, callback) {
        let sdata = req.body;
        let did = sdata.DID;
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "+1" + number;
        var headers = {
            'accept': '*/*',
            'Accept': 'application/json'
        };
        var dataString = '{"phone_number":"' + number1 + '", "projectId":"' + projectId + '", "region_code":"US", "smsConfiguration":{"servicePlanId":"' + servicePlanId + '", "campaignId":"' + sdata.CampaignId + '"}}';
        var options = {
            url: 'https://imported.numbers.api.sinch.com/v1beta1/projects/' + projectId + '/importedNumbers/' + number1,
            method: 'PATCH',
            headers: headers,
            body: dataString,
            auth: {
                'user': userId,
                'pass': passwd
            }
        };
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                if (data.status == "WAITING") {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE `did_buy` SET `sinch_status` = 'register' where `iduser` = '" + this.sessdata.iduser + "' AND `did`='" + number + "'";
                    obj.prepare();
                    obj.execute((err, resp) => {
                        if (resp) {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({});
                            obj.execute();
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ "error": "Query Error", "err": err });
                            obj.execute();
                        }
                    });
                }
            }
            else {
                callback(error, "");
            }
        });
    }
    /* <=== toll-free provisioning Osr Update Entry Type3 ==> */
    deleteNumber(req, res, callback) {
        let sdata = req.query;
        let did = sdata.DID;
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "1" + number;
        var headers = {
            'accept': '*/*',
            'Accept': 'application/json'
        };
        var options = {
            url: 'https://imported.numbers.api.sinch.com/v1beta1/projects/' + projectId + '/importedNumbers/' + number1,
            method: 'GET',
            headers: headers,
            auth: {
                'user': userId,
                'pass': passwd
            }
        };
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                if (data.status == 200) {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE `did_buy` SET `sinch_status` = '0', where iduser = '" + this.sessdata.iduser + "' AND `did`='" + number + "'";
                    obj.prepare();
                    obj.execute((err, resp) => {
                        if (err == 1) {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 202, message: "Disabled successfully" });
                            obj.execute();
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 502, message: "Something Went Wrong" });
                            obj.execute();
                        }
                    });
                }
                else {
                    callback('', data);
                }
            }
            else {
                callback(error, '');
            }
        });
    }
    updateNumberWithTollfree(req, res, callback) {
        let sdata = req.body;
        let options = {
            'method': 'PUT',
            'url': 'https://208.254.45.98/osr/v2/entries/1800551212',
            'headers': {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({ "id": "mypid", "nnid": "123456", "context": "A2P", "ownertspid": "3434" })
        };
        request(options, (error, response) => {
            if (!error) {
                let ddata = JSON.parse(response.body);
                if (ddata.rows.length > 0) {
                }
                else {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.prepare();
                    obj.execute((err, data) => {
                        callback(err, data);
                    });
                }
            }
            else {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.prepare();
                obj.execute((err, data) => {
                    callback(err, data);
                });
            }
        });
    }
    retrieveOsrEntry(req, res, callback) {
        let sdata = req.query;
        let did = sdata.DID;
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "1" + number;
        let options = {
            'method': 'GET',
            'url': produrl + "" + number1 + "?id=" + myip,
            'headers': {
                'Content-Type': 'application/json'
            }
        };
        console.log("options", options);
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                callback('', data);
            }
            else {
                callback(error, '');
            }
        });
    }
}
exports.SinchApi = SinchApi;
