"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThinQAPI = void 0;
const APIBase_1 = require("./APIBase");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const RawQuery_1 = require("../lib/model/RawQuery");
const Osr_1 = require("./Osr");
const numberApi_1 = require("./numberApi");
const RawView_1 = require("../lib/view/RawView");
var request = require('request');
class ThinQAPI extends APIBase_1.APIBase {
    key;
    secret;
    priority;
    sessdata;
    timekey;
    constructor(proirity, sessdata, timekey) {
        super();
        this.key = "cGFua2FqQGd2ZW50dXJlLm5ldDpjYWRiZjViYTM4ODA2YjcxMjU1ZWE3YTRlNGM3MzQ1NzU3ODU5NTA5";
        this.timekey = timekey;
        this.secret = "";
        this.priority = proirity;
        this.sessdata = sessdata;
    }
    getNpaNxx(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "NN", (err, voice_rate) => {
                if (err = 1 && voice_rate.length > 0) {
                    const sdata = req.query;
                    console.log("sdata", sdata);
                    var url;
                    if (sdata.NPA != undefined) {
                        url = "https://api.thinq.com/inbound/get-numbers?searchType=domestic&searchBy=npa&quantity=" + sdata.Qty + "&contiguous=false&npa=" + sdata.NPA + "";
                    }
                    if (sdata.NPA != undefined && sdata.NXX != undefined) {
                        url = "https://api.thinq.com/inbound/get-numbers?searchType=domestic&searchBy=npanxx&quantity=" + sdata.Qty + "&contiguous=false&npa=" + sdata.NPA + "&nxx=" + sdata.NXX + "";
                    }
                    let options = {
                        'method': 'GET',
                        'url': url,
                        'headers': {
                            'Authorization': 'Basic ' + this.key
                        },
                    };
                    request(options, (error, response) => {
                        if (!error) {
                            let data = JSON.parse(response.body);
                            console.log("Reponcnce==>", data);
                            if (data.dids != undefined && data.dids.length > 0) {
                                let str = data.dids;
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                let found = false;
                                let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`camp_registry`,`path`,`idapi`,`key`) VALUE ";
                                str.forEach((ele) => {
                                    if (ele.thinqTier == 0) {
                                        let did = "" + ele.id + "";
                                        let number = did.substring(1, 11);
                                        qrystr += "('" + ele.didSummary + "','" + number + "', '', '" + ele.ratecenter + "', '" + ele.ratecenter + "', '" + ele.state + "', '', '', '', '" + "thinQ" + "', '" + this.sessdata.iduser + "', '" + this.priority + "','NN','" + ele.thinqTier + "','','" + voice_rate[0].rate + "','" + sdata.CampaignId + "','" + this.sessdata.path + "','" + this.sessdata.idapi + "','" + this.timekey + "'),";
                                        found = true;
                                    }
                                });
                                if (found)
                                    obj1.nonqrysql = qrystr.slice(0, -1);
                                else
                                    obj1.nonqrysql = "";
                                obj1.prepare();
                                obj1.execute((err, data) => {
                                    callback(err, data);
                                });
                            }
                            else {
                                callback('', data);
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 404, message: "Account setting invalid because rate not found" });
                    objv.execute();
                }
            });
        }
    }
    getByRate(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "NN", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    var sdata = req.query;
                    let options = {
                        'method': 'GET',
                        'url': "https://api.thinq.com/inbound/get-numbers?searchType=domestic&searchBy=ratecenter&quantity=" + sdata.Qty + "&contiguous=false&state=" + sdata.State + "&rateCenter=" + sdata.RateCenter + "",
                        'headers': {
                            'Authorization': 'Basic ' + this.key
                        },
                    };
                    console.log("Options", options);
                    request(options, (error, response) => {
                        if (!error) {
                            let data = JSON.parse(response.body);
                            console.log("data==>", data);
                            if (data.dids != undefined && data.dids.length > 0) {
                                let str = data.dids;
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                let found = false;
                                let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`camp_registry`,`path`,`idapi`,`key`) VALUE ";
                                str.forEach((ele) => {
                                    if (ele.thinqTier == 0) {
                                        let did = "" + ele.id + "";
                                        let number = did.substring(1, 11);
                                        qrystr += "('" + ele.didSummary + "','" + number + "', '', '" + ele.ratecenter + "', '" + ele.ratecenter + "', '" + ele.state + "', '', '', '', '" + "thinQ" + "', '" + this.sessdata.iduser + "', '" + this.priority + "','NN','" + ele.thinqTier + "','','" + voice_rate[0].rate + "','" + sdata.CampaignId + "','" + this.sessdata.path + "','" + this.sessdata.idapi + "','" + this.timekey + "'),";
                                        found = true;
                                    }
                                });
                                if (found)
                                    obj1.nonqrysql = qrystr.slice(0, -1);
                                else
                                    obj1.nonqrysql = "";
                                obj1.prepare();
                                obj1.execute((err, data) => {
                                    callback(err, data);
                                });
                            }
                            else {
                                callback('', data);
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 404, message: "Account setting invalid because rate not found" });
                    objv.execute();
                }
            });
        }
    }
    getTollFree(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "TF", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    var sdata = req.query;
                    var options = {
                        'method': 'GET',
                        'url': "https://api.thinq.com/inbound/get-numbers?searchType=tollfree&searchBy=&quantity=" + sdata.Qty + "&contiguous=false",
                        'headers': {
                            'Authorization': 'Basic ' + this.key
                        },
                    };
                    request(options, (error, response) => {
                        if (!error) {
                            let data = JSON.parse(response.body);
                            console.log("data", data);
                            if (data.dids != undefined && data.dids.length > 0) {
                                let str = data.dids;
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`path`,`idapi`,`key`) VALUE ";
                                str.forEach((ele) => {
                                    let did = "" + ele.id + "";
                                    let number = did.substring(1, 11);
                                    qrystr += "('" + ele.didSummary + "','" + number + "', '', '" + ele.ratecenter + "', '" + ele.ratecenter + "', '" + ele.state + "', '', '', '', '" + "thinQ" + "', '" + this.sessdata.iduser + "', '" + this.priority + "','TF','" + ele.thinqTier + "','','" + voice_rate[0].rate + "','" + this.sessdata.path + "','" + this.sessdata.idapi + "','" + this.timekey + "'),";
                                });
                                obj1.nonqrysql = qrystr.slice(0, -1);
                                obj1.prepare();
                                obj1.execute((err, data) => {
                                    callback(err, data);
                                });
                            }
                            else {
                                callback('', data);
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 404, message: "Account setting invalid because rate not found" });
                    objv.execute();
                }
            });
        }
    }
    buyDID(req, res, callback) {
        const sdata = req.body;
        let types;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let Did = did.slice(len, len + 10);
        let id_grouporder = sdata.id_grouporder;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
            obj1.qrysql = "SELECT `type`,`rates` from `did_search` WHERE `iduser`='" + this.sessdata.iduser + "' AND `phone_number`='" + sdata.DID.trim() + "'";
            obj1.prepare();
            obj1.execute((error, did_details) => {
                if (did_details.length > 0) {
                    //getting proration status
                    let objv0 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    objv0.nonqrysql = "SELECT t.proration FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
                    objv0.prepare();
                    objv0.execute((proration_error, proration_success) => {
                        if (proration_error == 1) {
                            let proration_status = proration_success[0].proration;
                            types = did_details[0].type == 'TF' ? 'TF' : 'NN';
                            var options = {
                                'method': 'POST',
                                'url': 'https://api.thinq.com/account/15080/origination/order/create',
                                'headers': {
                                    'Authorization': 'Basic ' + this.key,
                                    'Content-Type': 'application/json'
                                },
                                body: JSON.stringify({
                                    "order": {
                                        "tns": [
                                            {
                                                "route_id": 7818,
                                                "did": sdata.DID.trim()
                                            }
                                        ],
                                        "blocks": []
                                    }
                                })
                            };
                            request(options, (error, response) => {
                                console.log("response", response.body);
                                if (!error) {
                                    let data = JSON.parse(response.body);
                                    if (data.id != undefined) {
                                        console.log(data.id);
                                        var options = {
                                            'method': 'POST',
                                            'url': 'https://api.thinq.com/account/15080/origination/order/complete/' + `${data.id}`,
                                            'headers': {
                                                'Authorization': 'Basic ' + this.key,
                                                'Content-Type': 'application/json'
                                            }
                                        };
                                        request(options, (error, response) => {
                                            let ddata = JSON.parse(response.body);
                                            if (!error) {
                                                if (ddata.code == 404) {
                                                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + ddata.code + "','" + Did + "', '4', '" + data.id + "', '" + types + "', '" + did_details[0].rates + "', '" + data.message + "', " + id_grouporder + ")";
                                                    obj.prepare();
                                                    obj.execute((did_err, did_data) => {
                                                        if (did_err == 1) {
                                                            let obj = new RawView_1.RawView(res);
                                                            obj.prepare({ status: ddata.code, result: ddata });
                                                            obj.execute();
                                                        }
                                                        else {
                                                            let obj = new RawView_1.RawView(res);
                                                            obj.prepare({ status: ddata.code, result: ddata });
                                                            obj.execute();
                                                        }
                                                    });
                                                }
                                                else {
                                                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = "INSERT INTO `did_buy` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`) VALUE('" + ddata.account_id + "','" + ddata.user_id + "','" + ddata.status + "','" + Did + "','thinQ','" + data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + this.sessdata.idapi + "')";
                                                    obj.prepare();
                                                    obj.execute((did_err, did_data) => {
                                                        if (did_err == 1) {
                                                            let dateObj = new Date();
                                                            let day = dateObj.getUTCDate();
                                                            let totalDays = 30 - day + 1;
                                                            let prorate = 0;
                                                            if (proration_status == "true") {
                                                                prorate = (totalDays * did_details[0].rates) / 30;
                                                            }
                                                            else {
                                                                prorate = did_details[0].rates;
                                                            }
                                                            console.log(prorate);
                                                            let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                            objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                                            objv.prepare();
                                                            objv.execute((wallet_error, wallet_success) => {
                                                                let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                                iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                                                iQry += "`amount`='-" + prorate + "', ";
                                                                iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                                                iQry += "`status`=1;";
                                                                let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                objWL.nonqrysql = iQry;
                                                                objWL.prepare();
                                                                objWL.execute((error, result) => {
                                                                    console.log("Transaction response::", result);
                                                                });
                                                                let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`) VALUE('','','completed','" + Did + "','thinQ','" + data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "')";
                                                                objv1.prepare();
                                                                objv1.execute((log_error, did_log) => {
                                                                    let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                    obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + sdata.DID + "'";
                                                                    obj5.prepare();
                                                                    obj5.execute((walletError1, wallet1) => {
                                                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + ddata.status + "','" + Did + "', '2', '" + data.id + "', '" + types + "', '" + did_details[0].rates + "', '" + data.message + "', " + id_grouporder + ")";
                                                                        obj.prepare();
                                                                        obj.execute((did_err, did_data) => {
                                                                            if (sdata.CampaignId && types == "NN") {
                                                                                let osr = new Osr_1.OsrApi(this.priority, this.sessdata);
                                                                                osr.updateNumber(req, res, data.insertId, (error, responce) => {
                                                                                    if (responce) {
                                                                                        return callback('', responce);
                                                                                    }
                                                                                    else {
                                                                                        callback(error, '');
                                                                                    }
                                                                                });
                                                                            }
                                                                            else {
                                                                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                                                obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_data.insertId + "' ";
                                                                                obj2.prepare();
                                                                                obj2.execute((did_err, did_result) => {
                                                                                    if (did_err == 1) {
                                                                                        let obj = new RawView_1.RawView(res);
                                                                                        obj.prepare({ status: 201, message: "DID buy successfully", result: did_result });
                                                                                        obj.execute();
                                                                                    }
                                                                                });
                                                                            }
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        }
                                                        else {
                                                            let obj = new RawView_1.RawView(res);
                                                            obj.prepare({ status: 502, message: "Something went wrong with connection!" });
                                                            obj.execute();
                                                        }
                                                    });
                                                }
                                            }
                                            else {
                                                let obj = new RawView_1.RawView(res);
                                                obj.prepare({ status: 400, error: error });
                                                obj.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let obj = new RawView_1.RawView(res);
                                        obj.prepare({ status: data.code, message: data.message, error: data });
                                        obj.execute();
                                    }
                                }
                                else {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({ status: 400, error: error });
                                    obj.execute();
                                }
                            });
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 502, message: "Something went wrong with get proration!" });
                            obj.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 404, message: "Did Not Available" });
                    objv.execute();
                }
            });
        });
    }
    disconnectDID(req, res, callback) {
        let sdata = req.body;
        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
        obj1.qrysql = "SELECT `day_num` from `tariff` WHERE `idtariff`='" + this.sessdata.idtariff + "'";
        obj1.prepare();
        obj1.execute((errday, resday) => {
            if (errday == 1 && resday.length > 0) {
                let number = new numberApi_1.Number();
                number.countDays(req, res, sdata.DID.trim(), (err, countdays) => {
                    if (countdays) {
                        if (countdays > resday[0].day_num) {
                            var options = {
                                'method': 'POST',
                                'url': 'https://api.thinq.com/account/15080/origination/disconnect',
                                'headers': {
                                    'Content-Type': 'application/json',
                                    'Authorization': 'Basic ' + this.key
                                },
                                body: JSON.stringify({
                                    "dids": [sdata.DID.trim()]
                                })
                            };
                            request(options, (error, response) => {
                                if (!error) {
                                    let data = JSON.parse(response.body);
                                    if (data.status == "completed") {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "UPDATE `did_buy` set `disconnect_did_status`='3',`updated_at`=NOW() WHERE `did`='" + sdata.DID.trim() + "'AND `iduser`='" + this.sessdata.iduser + "'";
                                        obj.prepare();
                                        obj.execute((error, resp) => {
                                            if (error == 1) {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: 201, message: "DID Disconnected Successfully" });
                                                objv.execute();
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: 502, message: "Something went wrong with connection" });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ status: data.code, message: data.message });
                                        objv.execute();
                                    }
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ status: 400, error: error });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 417, message: "Days are Less then " + resday[0].day_num + " So you can not disconnect Did from this Account" });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ status: 404, message: "Data Not Found" });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ status: 502, message: "Days Not Found!" });
                objv.execute();
            }
        });
    }
    /**
     * For bulk DID purchase callback method
     */
    buyDID_CB(req, res, DID, callback) {
        const sdata = req.body;
        let types;
        let did = DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let Did = did.slice(len, len + 10);
        let id_grouporder = sdata.id_grouporder;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
            obj1.qrysql = "SELECT `type`,`rates` from `did_search` WHERE `iduser`='" + this.sessdata.iduser + "' AND `phone_number`='" + DID.trim() + "'";
            obj1.prepare();
            obj1.execute((error, did_details) => {
                if (did_details.length > 0) {
                    //getting proration status
                    let objv0 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    objv0.nonqrysql = "SELECT t.proration FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
                    objv0.prepare();
                    objv0.execute((proration_error, proration_success) => {
                        if (proration_error == 1) {
                            let proration_status = proration_success[0].proration;
                            types = did_details[0].type == 'TF' ? 'TF' : 'NN';
                            var options = {
                                'method': 'POST',
                                'url': 'https://api.thinq.com/account/15080/origination/order/create',
                                'headers': {
                                    'Authorization': 'Basic ' + this.key,
                                    'Content-Type': 'application/json'
                                },
                                body: JSON.stringify({
                                    "order": {
                                        "tns": [
                                            {
                                                "route_id": 7818,
                                                "did": DID.trim()
                                            }
                                        ],
                                        "blocks": []
                                    }
                                })
                            };
                            request(options, (error, response) => {
                                console.log("response", response.body);
                                if (!error) {
                                    let data = JSON.parse(response.body);
                                    if (data.id != undefined) {
                                        console.log(data.id);
                                        var options = {
                                            'method': 'POST',
                                            'url': 'https://api.thinq.com/account/15080/origination/order/complete/' + `${data.id}`,
                                            'headers': {
                                                'Authorization': 'Basic ' + this.key,
                                                'Content-Type': 'application/json'
                                            }
                                        };
                                        request(options, (error, response) => {
                                            let ddata = JSON.parse(response.body);
                                            if (!error) {
                                                if (ddata.code == 404) {
                                                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + ddata.code + "','" + Did + "', '4', '" + data.id + "', '" + types + "', '" + did_details[0].rates + "', '" + data.message + "', " + id_grouporder + ")";
                                                    obj.prepare();
                                                    obj.execute((did_err, did_data) => {
                                                        if (did_err == 1) {
                                                            callback("", { error: 0, status: 200, message: "Successfully created", result: did_data });
                                                        }
                                                        else {
                                                            callback(did_err, { error: 1, status: 401, message: "Failed!" });
                                                        }
                                                    });
                                                }
                                                else {
                                                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = "INSERT INTO `did_buy` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`) VALUE('" + ddata.account_id + "','" + ddata.user_id + "','" + ddata.status + "','" + Did + "','thinQ','" + data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + this.sessdata.idapi + "')";
                                                    obj.prepare();
                                                    obj.execute((did_err, did_data) => {
                                                        if (did_err == 1) {
                                                            let dateObj = new Date();
                                                            let day = dateObj.getUTCDate();
                                                            let totalDays = 30 - day + 1;
                                                            let prorate = 0;
                                                            if (proration_status == "true") {
                                                                prorate = (totalDays * did_details[0].rates) / 30;
                                                            }
                                                            else {
                                                                prorate = did_details[0].rates;
                                                            }
                                                            console.log(prorate);
                                                            let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                            objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                                            objv.prepare();
                                                            objv.execute((wallet_error, wallet_success) => {
                                                                let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                                iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                                                iQry += "`amount`='-" + prorate + "', ";
                                                                iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                                                iQry += "`status`=1;";
                                                                let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                objWL.nonqrysql = iQry;
                                                                objWL.prepare();
                                                                objWL.execute((error, result) => {
                                                                    console.log("Transaction response::", result);
                                                                });
                                                                let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`) VALUE('','','completed','" + Did + "','thinQ','" + data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "')";
                                                                objv1.prepare();
                                                                objv1.execute((log_error, did_log) => {
                                                                    let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                    obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + DID + "'";
                                                                    obj5.prepare();
                                                                    obj5.execute((walletError1, wallet1) => {
                                                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + ddata.status + "','" + Did + "', '2', '" + data.id + "', '" + types + "', '" + did_details[0].rates + "', '" + data.message + "', " + id_grouporder + ")";
                                                                        obj.prepare();
                                                                        obj.execute((did_err, did_data) => {
                                                                            if (sdata.CampaignId && types == "NN") {
                                                                                let osr = new Osr_1.OsrApi(this.priority, this.sessdata);
                                                                                osr.updateNumber_CB(req, res, data.insertId, (error, responce) => {
                                                                                    if (responce.error == 0) {
                                                                                        callback("", { error: 0, status: responce.status, message: responce.message });
                                                                                    }
                                                                                    else {
                                                                                        callback(error, { error: 1, status: responce.status, message: responce.message });
                                                                                    }
                                                                                });
                                                                            }
                                                                            else {
                                                                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                                                obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_data.insertId + "' ";
                                                                                obj2.prepare();
                                                                                obj2.execute((did_err, did_result) => {
                                                                                    callback(error, { error: 0, status: 200, message: "DID buy successfully" });
                                                                                });
                                                                            }
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        }
                                                        else {
                                                            callback(did_err, { error: 1, status: 401, message: "Something went wrong with connection!" });
                                                        }
                                                    });
                                                }
                                            }
                                            else {
                                                callback(error, { error: 1, status: 400, message: error });
                                            }
                                        });
                                    }
                                    else {
                                        callback(error, { error: 1, status: data.code, message: data.message });
                                    }
                                }
                                else {
                                    callback(error, { error: 1, status: 400, message: error });
                                }
                            });
                        }
                        else {
                            callback(proration_error, { error: 1, status: 502, message: "Something went wrong with get proration!" });
                        }
                    });
                }
                else {
                    callback(error, { error: 1, status: 404, message: "Did Not Available!" });
                }
            });
        });
    }
}
exports.ThinQAPI = ThinQAPI;
