"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TwoFactorAuth = void 0;
const RawView_1 = require("../lib/view/RawView");
const Session_1 = require("../lib/model/Session");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const _406_1 = require("../lib/view/406");
const RawQuery_1 = require("../lib/model/RawQuery");
const net_1 = require("net");
const setting_config_1 = require("../config/setting.config");
const vs_server = new setting_config_1.VoiceServer();
const prefix = vs_server.Prefix;
const Str = require('@supercharge/strings');
var request = require('request');
class TwoFactorAuth {
    constructor() {
    }
    SendOtpBySMS(req, res, next) {
        let sdata = req.body.data;
        console.log("ressss", req.body.data.FROM);
        if (sdata.FROM != undefined && sdata.TO != undefined) {
            const uuid = Str.random(30);
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                if (error == 1) {
                    let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                    obj1.qrysql = "SELECT * FROM 2fa_template WHERE id2fa_template = '" + sdata.template + "' AND tmp_type='sms'";
                    obj1.execute((errr, rest) => {
                        if (errr == 1) {
                            let otp_size1 = '1';
                            let opt_size = '9';
                            console.log(rest[0].otp_digit);
                            for (let i = 1; i < rest[0].otp_digit; i++) {
                                opt_size += '0';
                                otp_size1 += '0';
                            }
                            let otp = Math.floor(parseInt(otp_size1) + Math.random() * parseInt(opt_size));
                            console.log("otp", otp);
                            let message = rest[0].body;
                            message = message.replace(/{OTP}/g, +otp);
                            console.log('Message Template', message);
                            var headers = {
                                'accept': '*/*',
                                'Authorization': sessdata.authkey,
                                'Content-Type': 'application/x-www-form-urlencoded'
                            };
                            var dataString = 'FROM=' + sdata.FROM + '&TO=' + sdata.TO + '&BODY=' + message;
                            var options = {
                                url: 'http://localhost:4219/sms',
                                method: 'POST',
                                headers: headers,
                                body: dataString
                            };
                            request(options, (error, responce) => {
                                if (!error) {
                                    let data = JSON.parse(responce.body);
                                    if (data.message == "Sms submit successfully") {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `two_factor_auth` (`from`, `to`,`iduser`,`otp`,`session_id`) VALUES('" + sdata.FROM + "','" + sdata.TO + "','" + sessdata.iduser + "','" + otp + "','" + uuid + "')";
                                        obj.prepare();
                                        obj.execute((otp_error, otp_resp) => {
                                            console.log("otp_resp", otp_resp);
                                            if (otp_error == 1) {
                                                let obj = new RawQuery_1.ModelRawQuery(req, res);
                                                obj.qrysql = "SELECT `session_id` FROM `two_factor_auth`  WHERE `id`='" + otp_resp.insertId + "'";
                                                obj.prepare();
                                                obj.execute((otp_err, resp) => {
                                                    if (otp_err == 1) {
                                                        let obj1 = new RawView_1.RawView(res);
                                                        obj1.prepare({ status: 200, message: "OTP send Successfully", result: resp });
                                                        obj1.execute();
                                                    }
                                                    else {
                                                        let obj1 = new RawView_1.RawView(res);
                                                        obj1.prepare({ status: 502, message: "Something went wrong" });
                                                        obj1.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let obj1 = new RawView_1.RawView(res);
                                                obj1.prepare({ status: 502, message: "Something went wrong" });
                                                obj1.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let obj1 = new RawView_1.RawView(res);
                                        obj1.prepare({ status: 502, message: data.message });
                                        obj1.execute();
                                    }
                                }
                                else {
                                    let obj1 = new RawView_1.RawView(res);
                                    obj1.prepare({ status: 502, message: "Something went wrong" });
                                    obj1.execute();
                                }
                            });
                        }
                        else {
                            let obj1 = new RawView_1.RawView(res);
                            obj1.prepare({ status: 502, message: "Something went wrong" });
                            obj1.execute();
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare(session);
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({ status: 500, message: "All fields are required, FROM, TO" });
            objv.execute();
        }
    }
    SendOtpByCall(req, res, next) {
        let sdata = req.body;
        console.log(sdata);
        if (sdata.FROM != undefined && sdata.TO != undefined) {
            const uuid = Str.random(30);
            // let otp: any = Math.floor(100000 + Math.random() * 900000).toString();
            // var otp1: any = "";
            // for (let i = 0; i <= otp.length - 1; i++) {
            //     otp1 += otp[i] + ". ";
            // }
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                if (error == 1) {
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    obj.qrysql = "SELECT * FROM 2fa_template WHERE id2fa_template='" + sdata.template + "'";
                    obj.prepare();
                    obj.execute((err, result) => {
                        if (err == 1) {
                            let otp_size1 = '1';
                            let opt_size = '9';
                            console.log(result[0].otp_digit);
                            for (let i = 1; i < result[0].otp_digit; i++) {
                                opt_size += '0';
                                otp_size1 += '0';
                            }
                            let otp = Math.floor(parseInt(otp_size1) + Math.random() * parseInt(opt_size)).toString();
                            var otp1 = "";
                            for (let i = 0; i <= otp.length - 1; i++) {
                                otp1 += otp[i] + ". ";
                            }
                            console.log("otp", otp);
                            let message = result[0].body;
                            message = message.replace(/{OTP}/g, ' ' + otp1);
                            console.log("message template", message);
                            let socketData = "{sip_cid_type=rpid,origination_caller_id_name=" + sdata.FROM.trim() + ",origination_caller_id_number=" + sdata.FROM.trim() + "}sofia/gateway/iplink/8279#" + sdata.TO.trim() + " &'javascript(tts.js " + message + ")'";
                            let client = new net_1.Socket();
                            client.connect(parseInt(vs_server.PORT), vs_server.HOST, function () {
                                console.log('CONNECTED TO: ' + vs_server.HOST + ':' + vs_server.PORT);
                                client.write('auth ' + vs_server.PASS + '\n\n');
                                console.log("Password : " + vs_server.PASS);
                                console.log(socketData);
                                client.write('api originate ' + socketData + '\n\n');
                                client.on("data", (respon) => {
                                    let tmp1 = respon.toString().split(" ");
                                    console.log("temp1", tmp1);
                                    if (tmp1[0] == '-ERR') {
                                        res.status(503).send({ message: respon.toString() });
                                    }
                                    else {
                                        let tmp = respon.toString().split("\n");
                                        tmp.forEach((elem) => {
                                            if (elem != undefined) {
                                                if (elem.length > 0) {
                                                    let tmp2 = elem.split(" ");
                                                    if (tmp2[0] == "-ERR") {
                                                        return res.status(503).send({ message: tmp2[1], status: 503 });
                                                    }
                                                    else {
                                                        let t1 = elem.split("OK");
                                                        if (t1.length == 2) {
                                                            console.log("t1", t1);
                                                            if (t1[0] == "+") {
                                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                obj.nonqrysql = "INSERT INTO `2fa_otp_voice`( `from`, `to`, `iduser`, `otp`,`session_id`) VALUES ('" + sdata.FROM + "','" + sdata.TO + "','" + sessdata.iduser + "','" + otp + "','" + sessdata.authkey + "')";
                                                                obj.prepare();
                                                                obj.execute((err, result) => {
                                                                    if (err == 1) {
                                                                        res.status(200).send({ message: "Call Connected Successfully", uuid: t1[1].trim(), status: 201 });
                                                                    }
                                                                    else {
                                                                        res.status(200).send({ message: "Call Connected Successfully But Error With Send OTP!", uuid: t1[1].trim(), status: 201 });
                                                                    }
                                                                });
                                                            }
                                                        }
                                                    }
                                                    // else{
                                                    // res.status(400).send({ message: "Call Connected Successfully", uuid: t1[1].trim() });
                                                    // }
                                                }
                                            }
                                        });
                                    }
                                });
                                client.on("error", (e) => {
                                    console.log(e);
                                });
                                client.on("end", () => {
                                });
                            });
                        }
                        else {
                            res.status(200).send({ message: "Call Connected Successfully But Error With Send OTP!", status: 201 });
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare(session);
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({ status: 500, message: "All fields are required, FROM, TO" });
            objv.execute();
        }
    }
    VerifyOtp(req, res, next) {
        let sdata = req.body;
        if (sdata.OTP != undefined && sdata.SessionId != undefined) {
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                if (error == 1) {
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    obj.qrysql = "SELECT * FROM `two_factor_auth`  WHERE `otp`='" + sdata.OTP + "' AND `session_id`='" + sdata.SessionId + "' AND UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created)<300";
                    obj.execute((verf_otp_error, verf_otp_resp) => {
                        if (verf_otp_error == 1) {
                            if (verf_otp_resp.length > 0) {
                                let obj1 = new RawView_1.RawView(res);
                                obj1.prepare({ status: 200, message: "OTP Verified Successfully" });
                                obj1.execute();
                            }
                            else {
                                let obj1 = new RawView_1.RawView(res);
                                obj1.prepare({ status: 404, message: "Your OTP is expired" });
                                obj1.execute();
                            }
                        }
                        else {
                            let obj1 = new RawView_1.RawView(res);
                            obj1.prepare({ status: 502, message: "Something went wrong!" });
                            obj1.execute();
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare(session);
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({ status: 500, message: "All fields are required, FROM, TO" });
            objv.execute();
        }
    }
    verifyCallOtp(req, res, next) {
        let sdata = req.body;
        if (sdata.otp != undefined) {
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                if (error == 1) {
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    obj.qrysql = "SELECT * FROM `2fa_otp_voice` WHERE `otp`='" + sdata.otp + "' AND `session_id`='" + sessdata.authkey + "' AND UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created_at)<300";
                    obj.execute((verf_otp_error, verf_otp_resp) => {
                        if (verf_otp_error == 1) {
                            if (verf_otp_resp.length > 0) {
                                let obj1 = new RawView_1.RawView(res);
                                obj1.prepare({ status: 200, message: "OTP Verified Successfully" });
                                obj1.execute();
                            }
                            else {
                                let obj1 = new RawView_1.RawView(res);
                                obj1.prepare({ status: 404, message: "Invalid OTP!" });
                                obj1.execute();
                            }
                        }
                        else {
                            let obj1 = new RawView_1.RawView(res);
                            obj1.prepare({ status: 502, message: "Something went wrong to Match Otp!" });
                            obj1.execute();
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare(session);
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({ status: 500, message: "OTP required" });
            objv.execute();
        }
    }
}
exports.TwoFactorAuth = TwoFactorAuth;
