"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Connection = void 0;
const RawView_1 = require("../lib/view/RawView");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const Session_1 = require("../lib/model/Session");
const _406_1 = require("../lib/view/406");
const AppRoute_1 = require("../lib/AppRoute");
const RawQuery_1 = require("../lib/model/RawQuery");
const Str = require('@supercharge/strings');
class Connection extends AppRoute_1.AppRoute {
    constructor() {
        super();
    }
    getConnections(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                if (sessdata.type == 22) {
                    obj.qrysql = "SELECT * FROM `endpoint` WHERE `iduser`= '" + sessdata.iduser + "'";
                }
                else {
                    obj.qrysql = "SELECT e.*, CONCAT(us.firstname,' ',us.lastname) AS fullname FROM `endpoint`e JOIN `user_profile`us ON us.iduser = e.iduser WHERE e.`idaccount`= '" + sessdata.idaccount + "'";
                }
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Connection Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    // getDid
    getDid(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM did_buy";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Did Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    AddCredential(req, res, next) {
        var rdata = [];
        rdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body;
                obj2.filter = null;
                obj2.qrysql = "UPDATE `endpoint` SET `username`='" + rdata.Username + "', `password`='" + rdata.Password + "' WHERE `connection_key`='" + rdata.ConnectionKey + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Connection Add Successfully",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    AddIP(req, res, next) {
        console.log("Sumit", req.body);
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT idendpoint FROM `endpoint` where `connection_key`='" + req.body.ConnectionKey + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let rdata = [];
                            let da = req.body.IP.split(',');
                            da.forEach((element) => {
                                rdata.push({ idendpoint: result[0].idendpoint, ip: element });
                            });
                            rdata.forEach((element) => {
                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                obj2.qrysql = "INSERT INTO ip_address (`idendpoint`, `ip`) VALUES('" + element.idendpoint + "', '" + element.ip + "')";
                                obj2.prepare();
                                obj2.execute((_error, allcamp) => {
                                });
                            });
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 201, message: "IP Add Successfully!" });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Data not found", status: 404 });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    UpdateIP(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT idendpoint FROM `endpoint` where `connection_key`='" + req.body.ConnectionKey + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let rdata = [];
                            let da = req.body.IP.split(',');
                            da.forEach((element) => {
                                rdata.push({ idendpoint: result[0].idendpoint, ip: element });
                            });
                            let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                            obj3.qrysql = "delete from ip_address where idendpoint = '" + rdata[0].idendpoint + "'";
                            obj3.prepare();
                            obj3.execute((derror, allcamp) => {
                                if (derror == 1) {
                                    let sql = "INSERT INTO ip_address (`idendpoint`, `ip`) VALUES ";
                                    rdata.forEach((element) => {
                                        sql += "('" + element.idendpoint + "','" + element.ip + "'),";
                                    });
                                    sql = sql.substring(0, sql.length - 1);
                                    let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                    obj2.qrysql = sql;
                                    obj2.prepare();
                                    obj2.execute((_error, allcamp) => {
                                        if (_error == 1) {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                message: "IP Updated Successfully!",
                                                status: 201
                                            });
                                            objv.execute();
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                message: "Something Went Wrong With Connection!",
                                                status: 502
                                            });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let sql = "INSERT INTO ip_address (`idendpoint`, `ip`) VALUES ";
                                    rdata.forEach((element) => {
                                        sql += "('" + element.idendpoint + "','" + element.ip + "'),";
                                    });
                                    sql = sql.substring(0, sql.length - 1);
                                    let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                    obj2.qrysql = sql;
                                    obj2.prepare();
                                    obj2.execute((_error, allcamp) => {
                                        if (_error == 1) {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                message: "IP Updated Successfully!",
                                                status: 201
                                            });
                                            objv.execute();
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                message: "Something Went Wrong With Connection!",
                                                status: 502
                                            });
                                            objv.execute();
                                        }
                                    });
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                message: "Data not found!",
                                status: 404
                            });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    UpdataFqdn(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT idendpoint FROM `endpoint` where `connection_key`='" + req.body.ConnectionKey + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                            let rdata;
                            rdata = req.body;
                            obj2.filter = null;
                            obj2.qrysql = "UPDATE routing_profile SET FQDN_type='" + rdata.type + "', FQDN_user='" + rdata.user + "' WHERE idendpoint='" + result[0].idendpoint + "'";
                            obj2.prepare();
                            obj2.execute((_error, allcamp) => {
                                if (_error == 1) {
                                    let objv = new RawView_1.RawView(res);
                                    obj2.prepare();
                                    objv.prepare({
                                        status: 201,
                                        message: "Updated Successfully"
                                    });
                                    objv.execute();
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    obj2.prepare();
                                    objv.prepare({
                                        status: 502,
                                        message: "Something Went Wrong With Connection!"
                                    });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv2 = new RawView_1.RawView(res);
                            objv2.prepare({
                                status: 404,
                                message: "Data not found"
                            });
                            objv2.execute();
                        }
                    }
                    else {
                        let objv2 = new RawView_1.RawView(res);
                        objv2.prepare({
                            status: 502,
                            message: "Something went wrong with connection!"
                        });
                        objv2.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    AddForwardAll(req, res, next) {
        var rdata = [];
        rdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body;
                let number;
                switch (rdata.forward_type) {
                    case "Sip uri":
                        number = 1;
                        break;
                    case "Number":
                        number = 2;
                        break;
                    case "IP Address":
                        number = 3;
                        break;
                    case "Group":
                        number = 4;
                        break;
                    case "Extension":
                        number = 5;
                        break;
                }
                obj2.filter = null;
                obj2.qrysql = "UPDATE `endpoint` SET `forward_type`='" + number + "',`forward`='" + rdata.forward + "' WHERE `connection_key`='" + rdata.ConnectionKey + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Connection Updated Successfully",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    UpdateHookUrl(req, res, next) {
        let sdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let type, priority;
                switch (sdata.Type) {
                    case "CDR Url":
                        type = "cdr";
                        break;
                    case "SMS Recive":
                        type = "sms-received";
                        break;
                    case "SMS Status":
                        type = "sms-status";
                        break;
                }
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "UPDATE hooksetting SET url='" + sdata.Urls + "' WHERE idendpoint=(SELECT idendpoint FROM `endpoint` where `connection_key`='" + sdata.ConnectionKey + "') AND type='" + type + "'";
                obj.prepare();
                obj.execute((hook_error, hook_result) => {
                    if (hook_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Webhook Urls Updated Successfully", status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something went wrong with connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    getInbound(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM inbound WHERE idendpoint='" + sdata.type + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Inbound Connection Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getOutbound(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM outbound WHERE idendpoint='" + sdata.type + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Outbound Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getConnectionData(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM routing_profile";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Routing Profile Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getUrlData(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `hooksetting` WHERE `idendpoint`='" + sdata.type + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Hooksetting Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getExpertSetting(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `routing_profile` WHERE `idendpoint`='" + sdata.type + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Routing Profile Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    saveConnection(req, res, next) {
        const connection_key = Str.random(30);
        const randDigit = connection_key.slice(4, 12);
        var rdata = [];
        rdata = req.body.data != undefined ? req.body.data : req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                obj1.qrysql = "SELECT * FROM endpoint where name = '" + rdata.connectionName + "'";
                obj1.prepare();
                obj1.execute((_error, getConn) => {
                    if (_error == 1) {
                        if (getConn.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                message: "Connection Already Exists!",
                                status: 404
                            });
                            objv.execute();
                        }
                        else {
                            let obj8 = new RawQuery_1.ModelRawQuery(req, res);
                            obj8.qrysql = "SELECT * FROM endpoint where isDefault = 'true'";
                            obj8.prepare();
                            obj8.execute((cerror, getConn1) => {
                                if (cerror == 1) {
                                    var isDefault;
                                    if (getConn1.length > 0) {
                                        isDefault = "false";
                                    }
                                    else {
                                        isDefault = "true";
                                    }
                                    let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                    obj2.filter = null;
                                    const val = Math.floor(1000 + Math.random() * 9000);
                                    let username = sessdata.username + "@" + val;
                                    let password = randDigit;
                                    const inbound_key = Str.random(30);
                                    const outbound_key = Str.random(30);
                                    obj2.qrysql = "CALL addconnection('" + sessdata.idaccount + "', '" + sessdata.iduser + "', '" + rdata.connectionName + "', '" + connection_key + "', '" + username + "', '" + password + "', '" + inbound_key + "', '" + outbound_key + "', '" + isDefault + "')";
                                    obj2.prepare();
                                    obj2.execute((__error, allcamp) => {
                                        if (__error == 1) {
                                            let newData = allcamp[0];
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                data: newData[0],
                                                message: "Connection Saved Successfully!",
                                                status: 201
                                            });
                                            objv.execute();
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                data: allcamp[0],
                                                message: "Something Went Wrong With Connection",
                                                status: 502
                                            });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({
                                        message: "Something Went Wrong With DB Connection!",
                                        status: 502
                                    });
                                    objv.execute();
                                }
                            });
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With DB Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    getIP(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM ip_address WHERE idendpoint='" + sdata.type + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "IP Address Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    deleteConnection(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "DELETE FROM endpoint WHERE idendpoint = '" + req.query.id + "'";
                obj.prepare();
                obj.execute((_error, lastid) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Connection Deleted Successfully!", data: lastid[0], status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", data: lastid[0], status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    saveIP(req, res, next) {
        console.log("Sumit", req.body);
        var insertedData;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var rdata = [];
                rdata = req.body.data.IPArr;
                rdata.forEach((element) => {
                    let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                    obj2.qrysql = "INSERT INTO ip_address (`iduser`, `idaccount`, `idendpoint`, `ip`) VALUES('" + sessdata.iduser + "', '" + sessdata.idaccount + "', '" + element.idendpoint + "', '" + element.ip + "')";
                    obj2.prepare();
                    obj2.execute((_error, allcamp) => {
                    });
                });
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "IP Saved Successfully!" });
                objv.execute();
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    save_smsOutbound(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "SELECT * FROM `hooksetting` WHERE `idendpoint` = '" + rdata.idendpoint + "' AND `type`='" + rdata.type + "'";
                obj2.prepare();
                obj2.execute((_error, response) => {
                    if (_error == 1) {
                        if (response != null && response != '') {
                            let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                            obj3.qrysql = "UPDATE hooksetting SET `url`='" + rdata.delivery_url + "' WHERE `idendpoint` = '" + rdata.idendpoint + "' AND `type` = '" + rdata.type + "'";
                            obj3.execute((error, result) => {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, message: "Updated Successfully!", status: 201 });
                                objv.execute();
                            });
                        }
                        else {
                            let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                            obj3.qrysql = "INSERT INTO hooksetting(`idaccount`, `idendpoint`, `type`, `url`) VALUES ('" + sessdata.idaccount + "', '" + rdata.idendpoint + "', '" + rdata.type + "', '" + rdata.delivery_url + "')";
                            obj3.execute((error, result) => {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, message: "Saved Successfully!", status: 201 });
                                objv.execute();
                            });
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ error: response, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    save_smsInbound(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "SELECT * FROM `hooksetting` WHERE `idendpoint` = '" + rdata.idendpoint + "' AND `type`='" + rdata.type + "'";
                obj2.prepare();
                obj2.execute((_error, response) => {
                    if (_error == 1) {
                        if (response != null && response != '') {
                            let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                            obj3.qrysql = "UPDATE hooksetting SET `url`='" + rdata.url + "' WHERE `idendpoint` = '" + rdata.idendpoint + "' AND `type` = '" + rdata.type + "'";
                            obj3.execute((__error, result) => {
                                if (__error == 1) {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ data: result, message: "Updated Successfully", status: 201 });
                                    objv.execute();
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ data: result, message: "Updated Successfully", status: 502 });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                            obj3.qrysql = "INSERT INTO hooksetting(`idaccount`, `idendpoint`, `type`, `url`) VALUES ('" + sessdata.idaccount + "', '" + rdata.idendpoint + "', '" + rdata.type + "', '" + rdata.url + "')";
                            obj3.execute((__error, result) => {
                                if (__error == 1) {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ data: result, message: "Saved Successfully!", status: 201 });
                                    objv.execute();
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                                    objv.execute();
                                }
                            });
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    saveUrls(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let rdata = [];
                let result = [];
                rdata = req.body.data;
                rdata.forEach((element) => {
                    element.forEach((ele) => {
                        result[ele.field] = ele.value;
                    });
                    let sms_key = Str.random(30);
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "INSERT INTO hooksetting (`idaccount`,`idendpoint`, `type`, `url`, `priority`, `sms_key`) VALUES('" + sessdata.idaccount + "', '" + result.idendpoint + "', '" + result.type + "', '" + result.url + "', '" + result.ID + "', '" + sms_key + "')";
                    obj.prepare();
                    obj.execute((error, data) => {
                    });
                });
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Updated Successfully", status: 201 });
                objv.execute();
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    deleteIP(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "DELETE FROM ip_address WHERE id_ipaddress = '" + req.query.id + "'";
                obj.prepare();
                obj.execute((_error, lastid) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "IP Deleted Successfully.", data: lastid[0], status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", data: lastid[0], status: 201 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateInbound(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "UPDATE inbound SET dnis='" + rdata.dnis + "', ani='" + rdata.ani + "', ringback_timeout='" + rdata.ringback_timeout + "', answer_timeout='" + rdata.answer_timeout + "', channel_limit='" + rdata.channel_limit + "', sip_uri='" + rdata.sip_uri + "', media_type='" + rdata.media_type + "', enable_sip_compact='" + rdata.enable_sip_compact + "', enable_privacy_zone='" + rdata.enable_privacy_zone + "', enable_prack='" + rdata.enable_prack + "', recording='" + rdata.recording + "' WHERE idendpoint='" + rdata.idendpoint + "'";
                obj2.prepare();
                obj2.execute((_error, data) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: data,
                            message: "Inbound Updated Successfully!",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: data,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateOutbound(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                let ntype = req.body.data.type;
                console.log('typeeee', ntype);
                console.log('data outbound', rdata);
                obj2.filter = null;
                obj2.qrysql = "UPDATE outbound SET caller_id='" + rdata.caller_id + "', type='" + ntype + "', country='" + rdata.country + "', channel_limit='" + rdata.channel_limit + "', initiated_by='" + rdata.initiated_by + "', voice_profile='" + rdata.voice_profile + "', media_type='" + rdata.media_type + "', enable_ringback='" + rdata.ringback + "', generate_ringback='" + rdata.tone + "', recording='" + rdata.recording + "', uuid_detail='" + rdata.uuid_detail + "', amd='" + rdata.amd + "' WHERE idendpoint='" + rdata.idendpoint + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Outbound Updated Successfully",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateConnectionName(req, res, next) {
        var rdata = [];
        rdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                // let obj = new ModelRawQuery(req, res);
                // obj.qrysql = "SELECT * FROM endpoint where name = '"+rdata.connectionName+"'";
                // obj.prepare();
                // obj.execute((error: any, result: any) => {
                //     if(result[0]){
                //         let objv = new RawView(res);
                //         objv.prepare({  
                //             message: "Connection Already Exists!" 
                //         });
                //         objv.execute();
                //     }
                //     else{
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "UPDATE `endpoint` SET `name`='" + rdata.connectionName + "', `brandId`='" + rdata.brand + "', `campaignId`='" + rdata.campaign + "'  WHERE `idendpoint`='" + rdata.idendpoint + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Connection Updated Successfully",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
                //     }
                // });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateStatus(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "UPDATE endpoint SET status='" + req.body.data + "' WHERE idendpoint='" + req.query.id + "'";
                obj.prepare();
                obj.execute((_error, lastid) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Status Update Successfully.", data: lastid[0], status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Status Update Successfully.", data: lastid, status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateConnection(req, res, next) {
        var rdata = [];
        rdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "UPDATE `endpoint` SET `name`='" + rdata.connectionName + "', `username`='" + rdata.username + "', `password`='" + rdata.password + "', `tech_prefix`='" + rdata.tech_prefix + "',`forward_type`='" + rdata.forward_type + "',`forward`='" + rdata.forward + "', `brandId`='" + rdata.brand + "', `campaignId`='" + rdata.campaign + "' WHERE `idendpoint`='" + rdata.idendpoint + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Connection Updated Successfully",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateFQDN(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata;
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "UPDATE routing_profile SET FQDN_type='" + rdata.type + "', FQDN_user='" + rdata.user + "' WHERE idendpoint='" + rdata.idendpoint + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            status: 201,
                            message: "Updated Successfully"
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            status: 502,
                            message: "Something Went Wrong With Connection!"
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateIP(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let rdata = [];
                rdata = req.body.data.IPArr;
                let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                obj3.qrysql = "delete from ip_address where idendpoint = '" + rdata[0].idendpoint + "'";
                obj3.prepare();
                obj3.execute((derror, allcamp) => {
                    if (derror == 1) {
                        let sql = "INSERT INTO ip_address (`idendpoint`, `ip`) VALUES ";
                        rdata.forEach((element) => {
                            sql += "('" + element.idendpoint + "','" + element.ip + "'),";
                        });
                        sql = sql.substring(0, sql.length - 1);
                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                        obj2.qrysql = sql;
                        obj2.prepare();
                        obj2.execute((_error, allcamp) => {
                            if (_error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "IP Updated Successfully!",
                                    status: 201
                                });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Duplicate Entry Please Try Again!",
                                    status: 1062
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let sql = "INSERT INTO ip_address (`iduser`, `idaccount`,`idendpoint`, `ip`) VALUES ";
                        rdata.forEach((element) => {
                            sql += "('" + sessdata.iduser + "', '" + sessdata.idaccount + "','" + element.idendpoint + "','" + element.ip + "'),";
                        });
                        sql = sql.substring(0, sql.length - 1);
                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                        obj2.qrysql = sql;
                        obj2.prepare();
                        obj2.execute((_error, allcamp) => {
                            if (_error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "IP Updated Successfully!",
                                    data: allcamp,
                                    status: 201
                                });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Something Went Wrong With Connection!",
                                    status: 502
                                });
                                objv.execute();
                            }
                        });
                    }
                });
                // obj2.filter = null;
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateUrls(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let rdata = [];
                let result = [];
                rdata = req.body.data;
                rdata.forEach((element) => {
                    element.forEach((ele) => {
                        result[ele.field] = ele.value;
                    });
                    // if(result.idhooksetting){
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE hooksetting SET url='" + result.url + "' WHERE idendpoint='" + result.idendpoint + "' AND type='" + result.type + "'";
                    obj.prepare();
                    obj.execute((error, data) => {
                    });
                    // }
                    // else{
                    //     let sms_key = Str.random(30);
                    //     let obj = new ModelRawNonQuery(req, res);
                    //     obj.nonqrysql = "INSERT INTO hooksetting (`idaccount`,`idendpoint`, `type`, `url`, `priority`, `sms_key`) VALUES('" + sessdata.idaccount + "', '" +result.idendpoint + "', '" + result.type + "', '" + result.url + "', '" + result.ID + "', '"+sms_key+"')";
                    //     obj.prepare();
                    //     obj.execute((error: any, data: any) => {
                    //     });
                    // }
                });
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Updated Successfully", status: 201 });
                objv.execute();
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateExpertSetting(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.filter = null;
                obj2.qrysql = "UPDATE routing_profile SET encode_header='" + rdata.Encode + "', comfort_noise='" + rdata.enable_comfort + "', enable_on_net='" + rdata.enable_on_net + "', DTMF_type='" + rdata.DTMF_type + "' WHERE idendpoint='" + rdata.idendpoint + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Updated Successfully",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        obj2.prepare();
                        objv.prepare({
                            error: 0,
                            data: allcamp,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    listConnections(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "CALL ListConnection('" + sessdata.idaccount + "')";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "List Connection Fetched!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Wentr Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    setDefaultConnection(req, res, next) {
        let sdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((sessErr, sessData) => {
            if (sessErr == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "UPDATE `endpoint` SET `isDefault`='false' WHERE `iduser`='" + sessData.iduser + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "UPDATE `endpoint` SET `isDefault`='true' WHERE `idendpoint`='" + sdata.idendpoint + "'";
                        obj.prepare();
                        obj.execute((__error, _result) => {
                            if (__error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, message: "Default Connection Changed Successfully!", status: 201 });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, message: "Something Went Wrong With Connection", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Default Connection Not Changed DB Error!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
}
exports.Connection = Connection;
