'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwaggerLogin = void 0;
const module_config_1 = require("../config/module.config");
const ModelLogin_1 = require("./model/ModelLogin");
const Session_1 = require("./model/Session");
const RawView_1 = require("./view/RawView");
const _403_1 = require("./view/403");
class SwaggerLogin {
    sessdata;
    constructor() { }
    UserLogin(req, res, next) {
        console.log('req.bodyreq.bodyreq.bodyreq.bodyreq.body', req.body);
        req.body = { username: req.body.Username, password: req.body.Password };
        let obj = new ModelLogin_1.ModelLogin(req, res);
        let swlogin = new module_config_1.modSwagger();
        if (obj.prepare(swlogin)) {
            obj.execute((error, result) => {
                if (error == 2) {
                    let session = new Session_1.SessionManagment(req, res, next);
                    session.SetSession(result, (error, sessdata) => {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ session: result.authkey });
                        objv.execute();
                    });
                }
                else {
                    let objv = new _403_1.Res403(res);
                    objv.prepare({ message: "Invalid Username and password to set proper session" });
                    objv.execute();
                }
            });
        }
    }
}
exports.SwaggerLogin = SwaggerLogin;
