"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeleAPI = void 0;
const APIBase_1 = require("./APIBase");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const RawQuery_1 = require("../lib/model/RawQuery");
const numberApi_1 = require("./numberApi");
const RawView_1 = require("../lib/view/RawView");
var request = require('request');
class TeleAPI extends APIBase_1.APIBase {
    key;
    secret;
    priority;
    sessdata;
    timekey;
    constructor(proirity, sessdata, timekey) {
        super();
        this.key = "48de6c84-7726-4879-bc08-f7a5dcf63f1c";
        this.timekey = timekey,
            this.secret = "";
        this.priority = proirity;
        this.sessdata = sessdata;
    }
    getNpaNxx(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "NN", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    const sdata = req.query;
                    var options = {
                        'method': 'POST',
                        'url': 'https://apiv1.teleapi.net/dids/list?token=' + this.key + '&npa=' + `${sdata.NPA}` + '&limit=' + `${sdata.Qty}`,
                        'headers': {
                            'Content-Type': 'application/json'
                        }
                    };
                    request(options, (error, response) => {
                        let ddata = JSON.parse(response.body);
                        if (!error) {
                            if (ddata.code == 200) {
                                if (ddata.data.dids != undefined && ddata.data.dids.length > 0) {
                                    let str = ddata.data.dids;
                                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`camp_registry`,`path`,`idapi`,`key`) VALUE";
                                    str.forEach((ele) => {
                                        qrystr += "('','" + ele.number + "', '', '', '" + ele.ratecenter + "', '" + ele.state + "', '', '','', '" + "teleapi" + "', '" + this.sessdata.iduser + "', '" + this.priority + "','NN','" + ele.tier + "','nrc:" + ele.setup_rate + ",mrc:" + ele.monthly_rate + ",usage:" + ele.per_minute_rate + "','" + voice_rate[0].rate + "','" + sdata.CampaignId + "','" + this.sessdata.path + "','" + this.sessdata.idapi + "','" + this.timekey + "'),";
                                    });
                                    obj1.nonqrysql = qrystr.slice(0, -1);
                                    obj1.prepare();
                                    obj1.execute((err, data) => {
                                        callback(err, data);
                                    });
                                }
                                else {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({ message: "No DID's found on [" + sdata.NPA + "]" });
                                    obj.execute();
                                }
                            }
                            else {
                                callback('', ddata);
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    callback(err, voice_rate);
                }
            });
        }
    }
    getByRate(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "NN", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    const sdata = req.query;
                    var options = {
                        'method': 'POST',
                        'url': 'https://apiv1.teleapi.net/dids/list?token=' + this.key + '&state=' + `${sdata.State}` + '&ratecenter=' + `${sdata.RateCenter}` + '&limit=' + `${sdata.Qty}`,
                        'headers': {
                            'Content-Type': 'application/json'
                        }
                    };
                    request(options, (error, response) => {
                        let ddata = JSON.parse(response.body);
                        console.log("ddata", JSON.stringify(ddata));
                        if (!error) {
                            if (ddata.code == 200) {
                                if (ddata.data.dids != undefined && ddata.data.dids.length > 0) {
                                    let str = ddata.data.dids;
                                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`camp_registry`,`path`,`idapi`,`key`) VALUE";
                                    str.forEach((ele) => {
                                        qrystr += "('','" + ele.number + "', '', '', '" + ele.ratecenter + "', '" + ele.state + "', '', '','', '" + "teleapi" + "', '" + this.sessdata.iduser + "', '" + this.priority + "','NN','" + ele.tier + "','nrc:" + ele.setup_rate + ",mrc:" + ele.monthly_rate + ",usage:" + ele.per_minute_rate + "','" + voice_rate[0].rate + "','" + sdata.CampaignId + "','" + this.sessdata.path + "','" + this.sessdata.idapi + "','" + this.timekey + "'),";
                                    });
                                    obj1.nonqrysql = qrystr.slice(0, -1);
                                    obj1.prepare();
                                    obj1.execute((err, data) => {
                                        callback(err, data);
                                    });
                                }
                                else {
                                    callback('', ddata);
                                }
                            }
                            else {
                                callback('', ddata);
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    callback(err, voice_rate);
                }
            });
        }
    }
    getTollFree(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "TF", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    var sdata = req.query;
                    var options = {
                        'method': 'POST',
                        'url': 'https://apiv1.teleapi.net/dids/list?token=' + this.key + '&type=tollfree&limit=' + `${sdata.Qty}`,
                        'headers': {
                            'Content-Type': 'application/json'
                        }
                    };
                    request(options, (error, response) => {
                        let ddata = JSON.parse(response.body);
                        console.log("ddata", ddata);
                        console.log(ddata.code);
                        if (!error) {
                            if (ddata.code == 200) {
                                if (ddata.data.dids != undefined && ddata.data.dids.length > 0) {
                                    let str = ddata.data.dids;
                                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`path`,`idapi`,`key`) VALUE";
                                    str.forEach((ele) => {
                                        qrystr += "('','" + ele.number + "', '', '', '', '', '', '','', '" + "teleapi" + "', '" + this.sessdata.iduser + "', '" + this.priority + "','TF','','nrc:" + ele.setup_rate + ",mrc:" + ele.monthly_rate + ",usage:" + ele.per_minute_rate + "','" + voice_rate[0].rate + "','" + this.sessdata.path + "','" + this.sessdata.idapi + "','" + this.timekey + "'),";
                                    });
                                    obj1.nonqrysql = qrystr.slice(0, -1);
                                    obj1.prepare();
                                    obj1.execute((err, data) => {
                                        callback(err, data);
                                    });
                                }
                                else {
                                    callback('', ddata);
                                }
                            }
                            else {
                                callback('', ddata);
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    callback(err, voice_rate);
                }
            });
        }
    }
    buyDID(req, res, callback) {
        const sdata = req.body;
        let types;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let id_grouporder = sdata.id_grouporder;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
            obj1.qrysql = "SELECT `type`,`rates` from `did_search` WHERE `iduser`='" + this.sessdata.iduser + "' AND `phone_number`='" + sdata.DID.trim() + "'";
            obj1.prepare();
            obj1.execute((err, did_details) => {
                console.log("res", did_details[0].type);
                if (err == 1 && did_details.length > 0) {
                    //getting proration status
                    let objv0 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    objv0.nonqrysql = "SELECT t.proration FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
                    objv0.prepare();
                    objv0.execute((proration_error, proration_success) => {
                        if (proration_error == 1) {
                            let proration_status = proration_success[0].proration;
                            types = did_details[0].type == 'TF' ? 'TF' : 'NN';
                            var options = {
                                'method': 'POST',
                                'url': 'https://apiv1.teleapi.net/dids/order?token=' + this.key + '&number=' + `${sdata.DID.trim()}`,
                                'headers': {
                                    'Content-Type': 'application/json'
                                }
                            };
                            request(options, (error, response) => {
                                let sdata1 = JSON.parse(response.body);
                                if (!error) {
                                    if (sdata1.code == 200) {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_buy` (`npa`,`nxx`,`ratecenter`,`state`,`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`,`sms_provider`) VALUE('" + npa + "','" + nxx + "','" + ratecenter + "','" + state + "','','" + sdata1.data.user_id + "','completed','" + sdata1.data.number + "','teleapi','" + sdata1.data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + this.sessdata.idapi + "','teleapi')";
                                        obj.prepare();
                                        obj.execute((err, data) => {
                                            if (err == 1) {
                                                let dateObj = new Date();
                                                let day = dateObj.getUTCDate();
                                                let totalDays = 30 - day + 1;
                                                let prorate;
                                                if (proration_status == "true") {
                                                    prorate = (totalDays * did_details[0].rates) / 30;
                                                }
                                                else {
                                                    prorate = did_details[0].rates;
                                                }
                                                console.log(prorate);
                                                let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                                objv.prepare();
                                                objv.execute((wallet_error, wallet_success) => {
                                                    let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                    iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                                    iQry += "`amount`='-" + prorate + "', ";
                                                    iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                                    iQry += "`status`=1;";
                                                    let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objWL.nonqrysql = iQry;
                                                    objWL.prepare();
                                                    objWL.execute((error, result) => {
                                                        console.log("Transaction response::", result);
                                                    });
                                                    let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`) VALUE('','','completed','" + sdata1.data.number + "','teleapi','" + sdata1.data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "')";
                                                    objv1.prepare();
                                                    objv1.execute((log_error, did_log) => {
                                                        if (log_error == 1) {
                                                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                            obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + data.insertId + "' ";
                                                            obj2.prepare();
                                                            obj2.execute((did_err, did_result) => {
                                                                if (did_err == 1) {
                                                                    let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                    obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + sdata.DID + "'";
                                                                    obj5.prepare();
                                                                    obj5.execute((walletError, wallet) => {
                                                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`,`type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + sdata1.code + "','" + sdata.DID + "', '2', '" + sdata1.data.id + "', '" + types + "', '" + did_details[0].rates + "', '" + sdata1.status + "', " + id_grouporder + ")";
                                                                        obj.prepare();
                                                                        obj.execute((did_err, did_data) => {
                                                                            let obj = new RawView_1.RawView(res);
                                                                            obj.prepare({ status: 201, message: "DID buy successfully", result: did_result });
                                                                            obj.execute();
                                                                        });
                                                                    });
                                                                }
                                                            });
                                                        }
                                                    });
                                                });
                                            }
                                            else {
                                                let obj = new RawView_1.RawView(res);
                                                obj.prepare({ status: 502, message: "Something went wrong with connection" });
                                                obj.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + sdata1.code + "','" + sdata.DID + "', '4', '" + sdata1.data.id + "', '" + types + "', '" + sdata1.status + "', " + id_grouporder + ")";
                                        obj.prepare();
                                        obj.execute((did_err, did_data) => {
                                            if (did_err == 1) {
                                                let obj = new RawView_1.RawView(res);
                                                obj.prepare({ status: sdata1.code, message: sdata1.status, error: sdata1.data });
                                                obj.execute();
                                            }
                                            else {
                                                let obj = new RawView_1.RawView(res);
                                                obj.prepare({ status: sdata1.code, message: sdata1.status, error: sdata1.data });
                                                obj.execute();
                                            }
                                        });
                                    }
                                }
                                else {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({ status: 400, error: error });
                                    obj.execute();
                                }
                            });
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 502, message: "Something went wrong with get proration!" });
                            obj.execute();
                        }
                    });
                }
                else {
                    let obj = new RawView_1.RawView(res);
                    obj.prepare({ status: 502, message: "Something went wrong with connection" });
                    obj.execute();
                }
            });
        });
    }
    disconnectDID(req, res, callback) {
        const sdata = req.body;
        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
        obj1.qrysql = "SELECT `day_num` from `tariff` WHERE `idtariff`='" + this.sessdata.idtariff + "'";
        obj1.prepare();
        obj1.execute((errday, resday) => {
            if (errday == 1 && resday.length > 0) {
                let number = new numberApi_1.Number();
                number.countDays(req, res, sdata.DID.trim(), (err, countdays) => {
                    if (countdays) {
                        if (countdays > resday[0].day_num) {
                            let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                            obj5.qrysql = "SELECT `type` from `did_buy` WHERE `iduser`='" + this.sessdata.iduser + "' AND `did`='" + sdata.DID.trim() + "'";
                            obj5.prepare();
                            obj5.execute((err, ress) => {
                                if (err == 1 && ress.length > 0) {
                                    var options = {
                                        'url': 'https://apiv1.teleapi.net/user/dids/remove?token=' + this.key + '&number=' + `${sdata.DID.trim()}`,
                                        'headers': {
                                            'Content-Type': 'application/json'
                                        }
                                    };
                                    request(options, (error, response) => {
                                        if (!error) {
                                            let data = JSON.parse(response.body);
                                            if (data.code == 200) {
                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                obj.nonqrysql = "UPDATE `did_buy` set `disconnect_did_status`='3',`updated_at`=NOW() WHERE `did`='" + sdata.DID.trim() + "'AND `iduser`='" + this.sessdata.iduser + "'";
                                                obj.prepare();
                                                obj.execute((error, resp) => {
                                                    if (error == 1) {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ status: 201, message: "DID Disconnected Successfully" });
                                                        objv.execute();
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ status: 502, message: "Something went wrong with connection!" });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: data.code, message: data.status, error: data.data });
                                                objv.execute();
                                            }
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({ status: 400, error: error });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ status: 502, message: "Something went wrong with connection!" });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 417, message: "Days are Less then " + resday[0].day_num + " So you can not disconnect Did from this Account" });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ status: 404, message: "Data Not Found" });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ status: 502, message: "Days Not Found!" });
                objv.execute();
            }
        });
    }
    /**
     * For bulk DID purchase callback method
     */
    buyDID_CB(req, res, DID, callback) {
        const sdata = req.body;
        let types;
        let did = DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let id_grouporder = sdata.id_grouporder;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
            obj1.qrysql = "SELECT `type`,`rates` from `did_search` WHERE `iduser`='" + this.sessdata.iduser + "' AND `phone_number`='" + DID.trim() + "'";
            obj1.prepare();
            obj1.execute((err, did_details) => {
                console.log("res", did_details[0].type);
                if (err == 1 && did_details.length > 0) {
                    //getting proration status
                    let objv0 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    objv0.nonqrysql = "SELECT t.proration FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
                    objv0.prepare();
                    objv0.execute((proration_error, proration_success) => {
                        if (proration_error == 1) {
                            let proration_status = proration_success[0].proration;
                            types = did_details[0].type == 'TF' ? 'TF' : 'NN';
                            var options = {
                                'method': 'POST',
                                'url': 'https://apiv1.teleapi.net/dids/order?token=' + this.key + '&number=' + `${DID.trim()}`,
                                'headers': {
                                    'Content-Type': 'application/json'
                                }
                            };
                            request(options, (error, response) => {
                                let sdata1 = JSON.parse(response.body);
                                if (!error) {
                                    if (sdata1.code == 200) {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_buy` (`npa`,`nxx`,`ratecenter`,`state`,`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`,`sms_provider`) VALUE('" + npa + "','" + nxx + "','" + ratecenter + "','" + state + "','','" + sdata1.data.user_id + "','completed','" + sdata1.data.number + "','teleapi','" + sdata1.data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + this.sessdata.idapi + "','teleapi')";
                                        obj.prepare();
                                        obj.execute((err, data) => {
                                            if (err == 1) {
                                                let dateObj = new Date();
                                                let day = dateObj.getUTCDate();
                                                let totalDays = 30 - day + 1;
                                                let prorate;
                                                if (proration_status == "true") {
                                                    prorate = (totalDays * did_details[0].rates) / 30;
                                                }
                                                else {
                                                    prorate = did_details[0].rates;
                                                }
                                                console.log(prorate);
                                                let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                                objv.prepare();
                                                objv.execute((wallet_error, wallet_success) => {
                                                    let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                    iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                                    iQry += "`amount`='-" + prorate + "', ";
                                                    iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                                    iQry += "`status`=1;";
                                                    let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objWL.nonqrysql = iQry;
                                                    objWL.prepare();
                                                    objWL.execute((error, result) => {
                                                        console.log("Transaction response::", result);
                                                    });
                                                    let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`) VALUE('','','completed','" + sdata1.data.number + "','teleapi','" + sdata1.data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "')";
                                                    objv1.prepare();
                                                    objv1.execute((log_error, did_log) => {
                                                        if (log_error == 1) {
                                                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                            obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + data.insertId + "' ";
                                                            obj2.prepare();
                                                            obj2.execute((did_err, did_result) => {
                                                                if (did_err == 1) {
                                                                    let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                    obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + DID + "'";
                                                                    obj5.prepare();
                                                                    obj5.execute((walletError, wallet) => {
                                                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`,`type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + sdata1.code + "','" + DID + "', '2', '" + sdata1.data.id + "', '" + types + "', '" + did_details[0].rates + "', '" + sdata1.status + "', " + id_grouporder + ")";
                                                                        obj.prepare();
                                                                        obj.execute((did_err, did_data) => {
                                                                            callback(did_err, { error: 0, status: 200, message: "DID buy successfully", result: did_data });
                                                                        });
                                                                    });
                                                                }
                                                                else {
                                                                    callback(did_err, { error: 1, status: 400, message: "Did did not found!" });
                                                                }
                                                            });
                                                        }
                                                        else {
                                                            callback(log_error, { error: 1, status: 400, message: "Did order log did not created!" });
                                                        }
                                                    });
                                                });
                                            }
                                            else {
                                                callback(err, { error: 1, status: 502, message: "Something went wrong with connection!" });
                                            }
                                        });
                                    }
                                    else {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','" + sdata1.code + "','" + DID + "', '4', '" + sdata1.data.id + "', '" + types + "', '" + sdata1.status + "', " + id_grouporder + ")";
                                        obj.prepare();
                                        obj.execute((did_err, did_data) => {
                                            if (did_err == 1) {
                                                callback("", { error: 0, status: sdata1.code, message: sdata1.status, result: did_data });
                                            }
                                            else {
                                                callback(did_err, { error: 1, status: sdata1.code, message: sdata1.status });
                                            }
                                        });
                                    }
                                }
                                else {
                                    callback(error, { error: 1, status: 400, message: error });
                                }
                            });
                        }
                        else {
                            callback(proration_error, { error: 1, status: 502, message: "Something went wrong with get proration!" });
                        }
                    });
                }
                else {
                    callback(err, { error: 1, status: 502, message: "Something went wrong with connection!" });
                }
            });
        });
    }
}
exports.TeleAPI = TeleAPI;
