"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Campaign = void 0;
const RawView_1 = require("../lib/view/RawView");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const Session_1 = require("../lib/model/Session");
const _406_1 = require("../lib/view/406");
const AppRoute_1 = require("../lib/AppRoute");
const RawQuery_1 = require("../lib/model/RawQuery");
const request = require("request");
//Peoduction Key 
//  const authKey = "MjQ1QUJEQjExODFENDI0QTgzRDNGNjU4MzhGNDFCNTA6Qjg0OTMzMUM1NTA3NEI0MkFCMTQ0MEYzNjI2M0IwOEI=";
// Test Key
const authKey = 'MjU1REI2OEE3MEM3NDZBMUIxN0M1NzEyM0U0MEM4NEU6NDlCOUIzQUM2ODMwNDRFNkE2QzJGQ0Y3QUFFMjU2QUQ=';
// Test Url
const apiUrl = "https://csp-api-staging.campaignregistry.com/v1/";
// Production Url
// const apiUrl = "https://csp-api.campaignregistry.com/v1/";
class Campaign extends AppRoute_1.AppRoute {
    constructor() {
        super();
    }
    brandRegister(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((_error, sessdata) => {
            if (_error == 1) {
                let Obj = new RawQuery_1.ModelRawQuery(req, res);
                Obj.qrysql = "SELECT * FROM `wallet` WHERE `idaccount`='" + sessdata.idaccount + "' AND `balance` + `credit_limit` >= 4";
                Obj.prepare();
                Obj.execute((bErr, bRes) => {
                    if (bErr == 1) {
                        if (bRes.length > 0) {
                            let brandData = req.body;
                            console.log("payload::", brandData);
                            let options = {
                                'method': 'POST',
                                'url': apiUrl + 'brand/nonBlocking',
                                'headers': {
                                    'Content-Type': 'application/json',
                                    'Authorization': 'Basic ' + authKey
                                },
                                body: JSON.stringify(brandData)
                            };
                            request(options, (error, response, body) => {
                                console.log("error::", error);
                                console.log("responseBody::", response.body);
                                if (!error) {
                                    brandData.city = brandData.city.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                    let resData = JSON.parse(response.body);
                                    if (resData.brandId) {
                                        let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                                        obj3.qrysql = "INSERT into `brand` (`idaccount`, `iduser`, `company_name`, `brand_name`,`company_type`, `ein`, `brand_relation`, `address`, `city`, `state`, `postal_code`, `website`, `vertical_type`, `country`, `email`, `phone`, `brandId`, `cspId`, `registrationScore`, `universalEin`,  `referenceId`, `entityType`, `identityStatus`, `einIssuingCountry`, `mock`, `firstName`, `lastName`, `ipAddress`, `brandType`) VALUES('" + sessdata.idaccount + "', '" + sessdata.iduser + "', '" + brandData.companyName + "', '" + brandData.displayName + "', '" + brandData.entityType + "', '" + brandData.ein + "', '" + brandData.brandRelationship + "', '" + brandData.street + "', '" + brandData.city + "', '" + brandData.state + "', '" + brandData.postalCode + "', '" + brandData.website + "', '" + brandData.vertical + "', '" + brandData.country + "', '" + brandData.email + "', '" + brandData.phone + "', '" + resData.brandId + "', '" + resData.cspId + "', '" + resData.registrationScore + "', '" + resData.universalEin + "',  '" + resData.referenceId + "', '" + resData.entityType + "', '" + resData.identityStatus + "', '" + resData.einIssuingCountry + "', '" + resData.mock + "', '" + brandData.firstName + "', '" + brandData.lastName + "', '" + brandData.ipAddress + "', 'register')";
                                        obj3.execute((__error, result) => {
                                            if (__error == 1) {
                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                obj.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-4 WHERE `idaccount`='" + sessdata.idaccount + "'";
                                                obj.prepare();
                                                obj.execute((___error, resp) => {
                                                    let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                    iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                                                    iQry += "`amount`='-4', ";
                                                    iQry += "`purpose`='Wallet amount successfully updated for brand registration', ";
                                                    iQry += "`status`=1;";
                                                    let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objWL.nonqrysql = iQry;
                                                    objWL.prepare();
                                                    objWL.execute((error, result) => {
                                                        console.log("Transaction response::", result);
                                                    });
                                                    if (___error == 1) {
                                                        let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        obj3.nonqrysql = "INSERT INTO `brand_log` (`idaccount`, `iduser`, `brand_key`,`cost`, `date`, `description`) VALUES ('" + sessdata.idaccount + "', '" + sessdata.iduser + "','" + resData.brandId + "', '4', '" + Date.now() + "', 'Brand_Rate')";
                                                        obj3.prepare();
                                                        obj3.execute((log_error, _resp) => {
                                                            if (log_error == 1) {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ status: 201, brandId: resData.brandId, message: "Brand Register Successfully!" });
                                                                objv.execute();
                                                            }
                                                            else {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ status: 502, error: _resp, message: "Brand Registered! But Error With Log!" });
                                                                objv.execute();
                                                            }
                                                        });
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ error: resp, message: "Brand Registered Error With Updating Wallet!", status: 502 });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ error: result, message: "Brand Registered Error With Connection!", status: 502 });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: resData[0].field + " " + resData[0].description, status: 502 });
                                        objv.execute();
                                    }
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ error: bErr, message: "Please add funds to your account or contact support.", status: 503 });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ error: bErr, message: "Something Went Wrong to Fetch Balance!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    addBrand(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let brandData = req.body;
                console.log(brandData);
                let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                obj5.qrysql = "SELECT * FROM `brand` WHERE `brandId` = '" + brandData.brand_key + "'";
                obj5.prepare();
                obj5.execute((error, brand) => {
                    if (error == 1) {
                        if (brand.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                message: "Brand Already Exists!",
                                status: 404
                            });
                            objv.execute();
                        }
                        else {
                            let obj4 = new RawQuery_1.ModelRawQuery(req, res);
                            obj4.qrysql = "INSERT into `brand` (`idaccount`, `iduser`, `company_name`, `brand_relation`,`vertical_type`,`website`, `city`,`country`,`brand_name`, `brandId`, `brandType`) VALUES('" + sessdata.idaccount + "', '" + sessdata.iduser + "', '" + brandData.companyName + "','" + brandData.brandRelationship + "','" + brandData.vertical + "','" + brandData.website + "','" + brandData.city + "','" + brandData.country + "', '" + brandData.companyName + "','" + brandData.brand_key + "', 'add')";
                            obj4.execute((_error, result) => {
                                if (_error == 1) {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ status: 201, data: result, message: "Brand Added Successfully!" });
                                    objv.execute();
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ error: result, message: "Something Went Wrong With Connection!", status: 502 });
                                    objv.execute();
                                }
                            });
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ error: brand, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getBrand(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `brand` where `iduser` = '" + sessdata.iduser + "' AND `brandId`='" + sdata.type + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Brands Fetched Successfully!",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getBrands(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM brand where `deleted`='0' AND iduser = '" + sessdata.iduser + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Brand Fetched Successfully!",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    updateBrand(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                obj2.qrysql = "UPDATE brand SET `brand_name`='" + rdata.brand_name + "', `brand_description`='" + rdata.brand_description + "' WHERE `idbrand` = '" + rdata.idbrand + "'";
                obj2.prepare();
                obj2.execute((_error, allcamp) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: allcamp,
                            message: "Brand Updated successfully!",
                            status: 201
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: allcamp,
                            message: "Something went wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    // Campaign code
    getCampaign(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `campaign` where `iduser` = '" + sessdata.iduser + "' GROUP BY campaign_key";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Campaign Fetched Successfully!",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getCampaigns(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `campaign` where `iduser` = '" + sessdata.iduser + "' AND idbrand = '" + req.query.type + "' AND `status`=0 GROUP BY campaign_key";
                // SELECT * FROM `campaign` WHERE `iduser` =201 AND idbrand = (SELECT idbrand FROM `brand` WHERE brandId='BMN5X6K')
                // obj.nonqrysql = "SELECT * FROM `campaign` WHERE `iduser`= '"+sessdata.iduser+"' AND `idbrand` = (SELECT `idbrand` FROM `brand` WHERE `brandId`='"+req.query.type+"')";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Campaign Fetched Successfully!",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getCNPCampaign(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `campaign` WHERE `iduser` = '" + sessdata.iduser + "' AND `status`=1 GROUP BY campaign_key";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Campaign Fetched Successfully!",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    CampaignCases(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `campaign_cases`";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Campaign Case Fetches",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Connection!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getCampaignCases(req, res, callback) {
        let id;
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/usecase',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (_err, response, body) => {
            if (response.body) {
                let data = JSON.parse(response.body);
                if (!_err) {
                    // let tmp:any=[];
                    // Object.entries(data).forEach((ele:any)=>{
                    //   let t=ele[1];
                    //   t["isDisable"] = false;
                    //   t["name"]=ele[0];
                    //   tmp.push(t);
                    // });
                    // console.log(tmp);
                    // let tmpqurty="INSERT INTO `campaign_cases` (`name`, `displayName`, `minSubUsecases`, `maxSubUsecases`, `validSubUsecase`, `classification`) VALUES ";
                    // tmp.forEach((campaignData: any) => {
                    //     console.log(campaignData, "campData");
                    //     tmpqurty += "('"+campaignData.name+"', '"+campaignData.displayName+"', '"+campaignData.minSubUsecases+"', '"+campaignData.maxSubUsecases+"', '"+campaignData.validSubUsecase+"', '"+campaignData.classification+"'),";
                    // });
                    // let obj = new ModelRawNonQuery(req, res);
                    // obj.nonqrysql =tmpqurty.slice(0, -1);
                    // obj.prepare();
                    // obj.execute((_error: any, data: any) => {
                    //     if(data.length > 0){
                    //         let objv = new RawView(res);
                    //         objv.prepare({ message: "Cases Fetched Successfully!", data: data });
                    //         objv.execute();
                    //     }
                    //     else{
                    //         let objv = new RawView(res);
                    //         objv.prepare({ message: "Something Went Wrong!", error: _error });
                    //         objv.execute();
                    //     }
                    // });
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Campaign Cases Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", error: data, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something Went Wrong With Connection!", error: _err, status: 502 });
                objv.execute();
            }
        });
    }
    addCampaign(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let campData = req.body;
                let id;
                let options = {
                    'method': 'Get',
                    'url': apiUrl + 'partnerCampaign/' + campData.campaign_key + '/sharing',
                    'headers': {
                        'Content-Type': 'application/json',
                        'Authorization': 'Basic ' + authKey
                    }
                };
                request(options, (_err, response, body) => {
                    let data = JSON.parse(response.body);
                    if (response.statusCode == 200) {
                        if (!_err) {
                            let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                            obj5.qrysql = "SELECT * FROM `campaign` WHERE `campaign_key` = '" + campData.campaign_key + "'";
                            obj5.prepare();
                            obj5.execute((_error, campaign) => {
                                if (_error == 1) {
                                    //-- Get SMS Provider 
                                    obj5.qrysql = "SELECT p.`priority`, UPPER(u.`username`)`username` FROM preference p LEFT JOIN `user` u ON p.idsupplier=u.idaccount WHERE p.idservice=(SELECT idservice FROM `user` WHERE iduser = '" + sessdata.iduser + "' ) AND p.type='sms'";
                                    obj5.prepare();
                                    obj5.execute((proerr, provider) => {
                                        if (proerr == 1 && provider.length > 0) {
                                            if (campaign.length > 0) {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({
                                                    message: "Campaign Already Exists!",
                                                    status: 404
                                                });
                                                objv.execute();
                                            }
                                            else {
                                                let tmp = [];
                                                let options = {
                                                    'method': 'PUT',
                                                    'url': apiUrl + 'partnerCampaign/' + data.campaignId + '/sharing/' + provider[0].username,
                                                    'headers': {
                                                        'Content-Type': 'application/json',
                                                        'Authorization': 'Basic ' + authKey
                                                    }
                                                };
                                                request(options, (error, response, body) => {
                                                    let partnerCampaign = JSON.parse(response.body);
                                                    if (response.statusCode == 200) {
                                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        obj.nonqrysql = "INSERT INTO `campaign` (`iduser`,`idbrand`,`campaign_key`, `campaign_name`, `status`) VALUES ('" + sessdata.iduser + "','" + campData.brandId + "', '" + campData.campaign_key + "', '" + campData.campaignName + "', '1')";
                                                        obj.prepare();
                                                        obj.execute((__error, data) => {
                                                            if (__error == 1) {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ message: "Campaign Added Successfully!", result: data, status: 201 });
                                                                objv.execute();
                                                            }
                                                            else {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ message: "Something Went Wrong With Connection!", error: data, status: 502 });
                                                                objv.execute();
                                                            }
                                                        });
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ message: data[0].field + " " + data[0].description, error: error, status: 502 });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({
                                                status: 502,
                                                message: "Service Profile not found!",
                                                error: proerr,
                                                campaignId: null
                                            });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ message: "Something Went Wrong With Connection!", error: campaign, status: 502 });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: data[0].field + " " + data[0].description, status: 502 });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: data[0].field + " " + data[0].description, status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    registerCampaign(req, res, next) {
        let campData = req.body;
        console.log(campData);
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj0 = new RawQuery_1.ModelRawQuery(req, res);
                obj0.qrysql = "SELECT * From `campaign_cases` WHERE `name`='" + campData.usecase + "'";
                obj0.prepare();
                obj0.execute((campError, camp) => {
                    if (campError == 1) {
                        //-- Get SMS Provider 
                        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                        obj1.qrysql = "SELECT p.`priority`, UPPER(u.`username`)`username` FROM preference p LEFT JOIN `user` u ON p.idsupplier=u.idaccount WHERE p.idservice=(SELECT idservice FROM `user` WHERE iduser = '" + sessdata.iduser + "' ) AND p.type='sms'";
                        obj1.prepare();
                        obj1.execute((proerr, provider) => {
                            if (proerr == 1 && provider.length > 0) {
                                let CRate = typeof camp[0].rate != 'undefined' && camp[0].rate > 0 ? camp[0].rate : 0;
                                if (CRate > 0) {
                                    let Obj = new RawQuery_1.ModelRawQuery(req, res);
                                    Obj.qrysql = "SELECT * FROM `wallet` WHERE `idaccount`='" + sessdata.idaccount + "' AND `balance` + `credit_limit` >= '" + CRate + "'";
                                    Obj.prepare();
                                    Obj.execute((bErr, bRes) => {
                                        if (bErr == 1) {
                                            if (bRes.length > 0) {
                                                var key;
                                                let options = {
                                                    'method': 'POST',
                                                    'url': apiUrl + 'campaignBuilder',
                                                    'headers': {
                                                        'Content-Type': 'application/json',
                                                        'Authorization': 'Basic ' + authKey
                                                    },
                                                    body: JSON.stringify(campData)
                                                };
                                                request(options, (error, response, body) => {
                                                    if (!error) {
                                                        let resData = JSON.parse(response.body);
                                                        if (resData.campaignId) {
                                                            let tmp = [];
                                                            let options = {
                                                                'method': 'PUT',
                                                                'url': apiUrl + 'partnerCampaign/' + resData.campaignId + '/sharing/' + provider[0].username,
                                                                'headers': {
                                                                    'Content-Type': 'application/json',
                                                                    'Authorization': 'Basic ' + authKey
                                                                }
                                                            };
                                                            request(options, (error, response, body) => {
                                                                let partnerCampaign = JSON.parse(response.body);
                                                                if (response.body) {
                                                                    Object.entries(resData.mnoMetadata).forEach((ele) => {
                                                                        let t = ele[1];
                                                                        t["class"] = ele[0];
                                                                        tmp.push(t);
                                                                    });
                                                                    let campaignData1 = tmp;
                                                                    campData.sample1 = campData.sample1.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                                                    campData.sample2 = campData.sample2.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                                                    campData.sample3 = campData.sample3.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                                                    campData.sample4 = campData.sample4.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                                                    campData.sample5 = campData.sample5.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                                                    campData.description = campData.description.replace(/"/g, '\\"').replace(/'/g, "\\'");
                                                                    let tmpqurty = "INSERT INTO `campaign` (`iduser`,`idbrand`,`campaign_key`, `campaign_class`, `campaign_name`, `minMsgSamples`,`mno`, `mnoReview`, `mnoSupport`, `msgClass`, `noEmbeddedLink`, `noEmbeddedPhone`,`qualify`,`reqSubscriberHelp`, `reqSubscriberOptin`, `reqSubscriberOptout`, `surcharge`, `tpn`, `brandTier`, `campaign_description`, `downstreamCnpId`, `upstreamCnpId`, `sharingStatus`, `sharedDate`, `statusDate`, `vertical`, `sample1`, `sample2`, `sample3`, `sample4`, `sample5`, `usecase`, `subUsecases`) VALUES ";
                                                                    campaignData1.forEach((campaignData) => {
                                                                        tmpqurty += "('" + sessdata.iduser + "','" + campData.brandId + "', '" + resData.campaignId + "', '" + campaignData.class + "', '" + campData.campaignName + "', '" + campaignData.minMsgSamples + "', '" + campaignData.mno + "', '" + campaignData.mnoReview + "', '" + campaignData.mnoSupport + "', '" + campaignData.msgClass + "', '" + campaignData.noEmbeddedLink + "', '" + campaignData.noEmbeddedPhone + "', '" + campaignData.qualify + "', '" + campaignData.reqSubscriberHelp + "', '" + campaignData.reqSubscriberOptin + "', '" + campaignData.reqSubscriberOptin + "', '" + campaignData.surcharge + "', '" + campaignData.tpn + "', '" + campaignData.brandTier + "', '" + campData.description + "', '" + partnerCampaign.downstreamCnpId + "', '" + partnerCampaign.upstreamCnpId + "', '" + partnerCampaign.sharingStatus + "', '" + partnerCampaign.sharedDate + "', '" + partnerCampaign.statusDate + "', '" + campData.vertical + "', '" + campData.sample1 + "', '" + campData.sample2 + "', '" + campData.sample3 + "', '" + campData.sample4 + "', '" + campData.sample5 + "', '" + campData.usecase + "', '" + campData.subUsecases + "'),";
                                                                    });
                                                                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                    obj.nonqrysql = tmpqurty.slice(0, -1);
                                                                    obj.prepare();
                                                                    obj.execute((_error, data) => {
                                                                        if (_error == 1) {
                                                                            let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                            obj3.nonqrysql = "INSERT INTO `brand_log` (`idaccount`, `iduser`, `campaign_key`,`cost`, `date`, `description`) VALUES ('" + sessdata.idaccount + "', '" + sessdata.iduser + "','" + resData.campaignId + "', '" + CRate + "', '" + Date.now() + "', 'Campaign_Rate')";
                                                                            obj3.prepare();
                                                                            obj3.execute((___error, _resp) => {
                                                                                if (___error == 1) {
                                                                                    let obj4 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                                    obj4.nonqrysql = "INSERT INTO `campaign_log` (`idaccount`, `iduser`, `campaign_key`,`cost`, `description`) VALUES ('" + sessdata.idaccount + "', '" + sessdata.iduser + "','" + resData.campaignId + "', '" + campData.rate + "', 'Campaign_Rate')";
                                                                                    obj4.prepare();
                                                                                    obj4.execute((campErr, __resp) => {
                                                                                        if (campErr == 1) {
                                                                                            let obj2 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                                            obj2.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + CRate + " WHERE `idaccount`='" + sessdata.idaccount + "'";
                                                                                            obj2.prepare();
                                                                                            obj2.execute((__error, resp) => {
                                                                                                if (__error == 1) {
                                                                                                    let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                                                                    iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                                                                                                    iQry += "`amount`='-" + CRate + "', ";
                                                                                                    iQry += "`purpose`='Wallet amount successfully updated for campaign registration', ";
                                                                                                    iQry += "`status`=1;";
                                                                                                    let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                                                    objWL.nonqrysql = iQry;
                                                                                                    objWL.prepare();
                                                                                                    objWL.execute((error, result) => {
                                                                                                        console.log("Transaction response::", result);
                                                                                                    });
                                                                                                    let objv = new RawView_1.RawView(res);
                                                                                                    objv.prepare({ status: 201, message: "Campaign Register Successfully!", campaignId: resData.campaignId });
                                                                                                    objv.execute();
                                                                                                }
                                                                                                else {
                                                                                                    let objv = new RawView_1.RawView(res);
                                                                                                    objv.prepare({ status: 502, message: "Campaign Registered Error With Updating Wallet!", error: resp });
                                                                                                    objv.execute();
                                                                                                }
                                                                                            });
                                                                                        }
                                                                                        else {
                                                                                            let objv = new RawView_1.RawView(res);
                                                                                            objv.prepare({ status: 502, message: "Campaign Registered Error With Campaign Log!", campaignId: resData.campaignId, error: _resp });
                                                                                            objv.execute();
                                                                                        }
                                                                                    });
                                                                                }
                                                                                else {
                                                                                    let objv = new RawView_1.RawView(res);
                                                                                    objv.prepare({ status: 502, message: "Campaign Registered But Error With Log!", campaignId: resData.campaignId, error: _resp });
                                                                                    objv.execute();
                                                                                }
                                                                            });
                                                                        }
                                                                        else {
                                                                            let objv = new RawView_1.RawView(res);
                                                                            objv.prepare({ message: "Campaign Registered Error With Connection!", error: error, status: 502 });
                                                                            objv.execute();
                                                                        }
                                                                    });
                                                                }
                                                                else {
                                                                    let objv = new RawView_1.RawView(res);
                                                                    objv.prepare({ message: "Campaign Registered With Connection Error!", error: error, status: 502 });
                                                                    objv.execute();
                                                                }
                                                            });
                                                        }
                                                        else {
                                                            let objv = new RawView_1.RawView(res);
                                                            objv.prepare({ message: resData[0].field + " " + resData[0].description, status: 502 });
                                                            objv.execute();
                                                        }
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ error: bErr, message: "Please add funds to your account or contact support.", status: 503 });
                                                objv.execute();
                                            }
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({ error: bErr, message: "Something Went Wrong to Fetch Account Balance!", status: 502 });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                    iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                                    iQry += "`amount`='-" + CRate + "', ";
                                    iQry += "`purpose`='Billing prorate should be greater then 0 to register a campaign', ";
                                    iQry += "`status`=2;";
                                    let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    objWL.nonqrysql = iQry;
                                    objWL.prepare();
                                    objWL.execute((error, result) => {
                                        console.log("Transaction response::", result);
                                    });
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({
                                        status: 502,
                                        message: "Billing prorate should be greater then 0 to register a campaign!",
                                        error: ""
                                    });
                                    objv.execute();
                                }
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    status: 502,
                                    message: "Service Profile not found!",
                                    error: proerr,
                                    campaignId: null
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            status: 502,
                            message: "Error With Fatching Campaign Rates!",
                            error: camp,
                            campaignId: null
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /**
     * It will delete a single campaign
     */
    deleteCampaign(req, res, next) {
        let camp_key = req.query.id;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let options = {
                    'method': 'DELETE',
                    'url': apiUrl + 'campaign/' + camp_key,
                    'headers': {
                        'Content-Type': 'application/json',
                        'Authorization': 'Basic ' + authKey
                    }
                };
                request(options, (error, response, body) => {
                    if (!error) {
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "UPDATE `campaign` SET `deleted`=1, `delete_date`=NOW() WHERE `campaign_key`='" + camp_key + "' ";
                        obj.prepare();
                        obj.execute((__error, camp) => {
                            if (__error == 1) {
                                obj.nonqrysql = "DELETE FROM `brand_log` WHERE `campaign_key`='" + camp_key + "' ";
                                obj.prepare();
                                obj.execute((__error, lastid) => {
                                    if (__error == 1) {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({
                                            message: "Campaign Deleted Successfully!",
                                            data: lastid[0],
                                            status: 201
                                        });
                                        objv.execute();
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({
                                            message: "Something Went Wrong With Connection!",
                                            error: lastid,
                                            status: 502
                                        });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Something Went Wrong With Connection!",
                                    error: camp,
                                    status: 502
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Error in Campaign Deleting!",
                            error: response,
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /**
     * It will delete a single brand
     */
    DeleteBrand(req, res, next) {
        let brandid = req.query.id;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let options = {
                    'method': 'DELETE',
                    'url': apiUrl + 'brand/' + brandid,
                    'headers': {
                        'Content-Type': 'application/json',
                        'Authorization': 'Basic ' + authKey
                    }
                };
                request(options, (error, response, body) => {
                    let data = JSON.parse(body);
                    let respon = data[0].description;
                    //let respon =  response.statusCode;
                    if (response.statusCode == 204) {
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "UPDATE `brand` SET `deleted`=1, `delete_date`=NOW() WHERE `brandId`='" + brandid + "' ";
                        obj.prepare();
                        obj.execute((__error, brand) => {
                            if (__error == 1) {
                                obj.nonqrysql = "DELETE FROM `brand_log` WHERE `brand_key`='" + brandid + "'";
                                obj.prepare();
                                obj.execute((__error, lastid) => {
                                    if (__error == 1) {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({
                                            message: "Brand Deleted Successfully!",
                                            data: lastid[0],
                                            status: 201
                                        });
                                        objv.execute();
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({
                                            message: "Something Went Wrong With Brand!",
                                            error: lastid,
                                            status: 502
                                        });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Something Went Wrong With Update Brand!",
                                    error: brand,
                                    status: 502
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: respon,
                            error: response,
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    brandRelationship(req, res, next) {
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/brandRelationship',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (error, response, body) => {
            if (response.body) {
                let data = JSON.parse(response.body);
                if (!error) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Brand Relationship Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", error: error, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something Went Wrong With Connection!", error: error, status: 502 });
                objv.execute();
            }
        });
    }
    brandVertical(req, res, next) {
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/vertical',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (error, response) => {
            if (response) {
                let data = JSON.parse(response.body);
                // console.log(data);
                if (!error) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Brand Vertical Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", error: error, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something Went Wrong With Connection!", error: error, status: 502 });
                objv.execute();
            }
        });
    }
    brandEntityType(req, res, next) {
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/entityType',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (error, response, body) => {
            if (response.body) {
                let data = JSON.parse(response.body);
                // console.log(data);
                if (!error) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Brand Entity Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", error: error, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something Went Wrong With Connection!", error: error, status: 502 });
                objv.execute();
            }
        });
    }
    brandVettingClass(req, res, next) {
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/vettingClass',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (error, response, body) => {
            if (response.body) {
                let data = JSON.parse(response.body);
                // console.log(data);
                if (!error) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Brand Vetting Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something went Wrong With Connection!", error: error, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something went Wrong With Connection!", error: error, status: 502 });
                objv.execute();
            }
        });
    }
    brandDCA(req, res, next) {
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/dca',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (error, response, body) => {
            if (response.body) {
                let data = JSON.parse(response.body);
                // console.log(data);
                if (!error) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Brand DCA Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something went Wrong With Connection!", error: error, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something went Wrong With Connection!", error: error, status: 502 });
                objv.execute();
            }
        });
    }
    altBusinessIdType(req, res, next) {
        let options = {
            'method': 'Get',
            'url': apiUrl + 'enum/altBusinessIdType',
            'headers': {
                'Content-Type': 'application/json',
                'Authorization': 'Basic ' + authKey
            }
        };
        request(options, (error, response, body) => {
            if (response.body) {
                let data = JSON.parse(response.body);
                // console.log(data);
                if (!error) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Brand Business Type Fetched!", data: data, status: 200 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something went Wrong With Connection!", error: error, status: 502 });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something went Wrong With Connection!", error: error, status: 502 });
                objv.execute();
            }
        });
    }
    /** Other APIs */
    BrandRegister(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let brandData = req.body;
                let objv = new RawView_1.RawView(res);
                if (brandData.displayName && brandData.firstName && brandData.lastName && brandData.phone && brandData.street && brandData.city && brandData.state && brandData.postalCode && brandData.country && brandData.email && brandData.referenceId) {
                    let options = {
                        'method': 'POST',
                        'url': apiUrl + 'brand',
                        'headers': {
                            'Content-Type': 'application/json',
                            'Authorization': 'Basic ' + authKey
                        },
                        body: JSON.stringify(brandData)
                    };
                    request(options, (error, response, body) => {
                        if (!error) {
                            let resData = JSON.parse(response.body);
                            if (resData.brandId) {
                                let obj3 = new RawQuery_1.ModelRawQuery(req, res);
                                obj3.qrysql = "INSERT into `brand` (`iduser`, `company_name`, `brand_name`,`company_type`, `ein`, `brand_relation`, `address`, `city`, `state`, `postal_code`, `website`, `vertical_type`, `country`, `email`, `phone`, `brandId`, `cspId`, `registrationScore`, `universalEin`,  `referenceId`, `entityType`, `identityStatus`, `einIssuingCountry`, `mock`, `firstName`, `lastName`, `ipAddress`) VALUES('" + sessdata.iduser + "', '" + brandData.companyName + "', '" + brandData.displayName + "', '" + brandData.entityType + "', '" + brandData.ein + "', '" + brandData.brandRelationship + "', '" + brandData.street + "', '" + brandData.city + "', '" + brandData.state + "', '" + brandData.postalCode + "', '" + brandData.website + "', '" + brandData.vertical + "', '" + brandData.country + "', '" + brandData.email + "', '" + brandData.phone + "', '" + resData.brandId + "', '" + resData.cspId + "', '" + resData.registrationScore + "', '" + resData.universalEin + "',  '" + resData.referenceId + "', '" + resData.entityType + "', '" + resData.identityStatus + "', '" + resData.einIssuingCountry + "', '" + resData.mock + "', '" + brandData.firstName + "', '" + brandData.lastName + "', '" + brandData.ipAddress + "')";
                                obj3.execute((error, result) => {
                                    if (result) {
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-4 WHERE `idaccount`='" + sessdata.idaccount + "'";
                                        obj.prepare();
                                        obj.execute((_error, _resp) => {
                                            if (_error == 1) {
                                                let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                                                iQry += "`amount`='-4', ";
                                                iQry += "`purpose`='Wallet amount successfully updated for brand registration', ";
                                                iQry += "`status`=1;";
                                                let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                objWL.nonqrysql = iQry;
                                                objWL.prepare();
                                                objWL.execute((error, result) => {
                                                    console.log("Transaction response::", result);
                                                });
                                                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                obj3.nonqrysql = "INSERT INTO `brand_log` (`idaccount`, `iduser`,`brand_key`,`cost`, `date`, `description`) VALUES ('" + sessdata.idaccount + "', '" + sessdata.iduser + "','" + resData.brandId + "', '4', '" + Date.now() + "', 'Brand_Rate')";
                                                obj3.prepare();
                                                obj3.execute((__error, resp) => {
                                                    if (__error == 1) {
                                                        objv.prepare({
                                                            data: {
                                                                brandId: resData.brandId,
                                                                cspId: resData.cspId
                                                            },
                                                            message: "Brand Register Successfully!",
                                                            status: 201
                                                        });
                                                        objv.execute();
                                                    }
                                                    else {
                                                        objv.prepare({
                                                            error: resp,
                                                            message: "Something Went Wrong With Connection!",
                                                            status: 502
                                                        });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                objv.prepare({
                                                    error: _resp,
                                                    message: "Something Went Wrong With Connection!",
                                                    status: 502
                                                });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        objv.prepare({
                                            error: error,
                                            message: "Something Went Wrong!",
                                            status: 502
                                        });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                objv.prepare({
                                    message: resData[0].field + " " + resData[0].description,
                                    error: error,
                                    status: 502
                                });
                                objv.execute();
                            }
                        }
                    });
                }
                else {
                    objv.prepare({
                        status: 502,
                        error: "displayName, firstName, lastName, phone, street, city, state, postalCode, country, email, and referenceId are mendatory fields!"
                    });
                    objv.execute();
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    CampaignRegister(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let campData = req.body;
                let CRate = typeof campData.rate != 'undefined' && campData.rate > 0 ? campData.rate : 0;
                //-- Get SMS Provider 
                let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                obj1.qrysql = "SELECT p.`priority`, UPPER(u.`username`)`username` FROM preference p LEFT JOIN `user` u ON p.idsupplier=u.idaccount WHERE p.idservice=(SELECT idservice FROM `user` WHERE iduser = '" + sessdata.iduser + "' ) AND p.type='sms'";
                obj1.prepare();
                obj1.execute((proerr, provider) => {
                    if (proerr == 1 && provider.length > 0) {
                        if (CRate > 0) {
                            let objv = new RawView_1.RawView(res);
                            if (campData.brandId) {
                                var key;
                                let options = {
                                    'method': 'POST',
                                    'url': apiUrl + 'campaignBuilder',
                                    'headers': {
                                        'Content-Type': 'application/json',
                                        'Authorization': 'Basic ' + authKey
                                    },
                                    body: JSON.stringify(campData)
                                };
                                request(options, (error, response, body) => {
                                    let body2 = {};
                                    try {
                                        body2 = JSON.parse(body);
                                    }
                                    catch {
                                        body2 = body;
                                    }
                                    let campaignId = typeof body2.campaignId != 'undefined' ? body2.campaignId : "";
                                    if (!error) {
                                        let resData = JSON.parse(response.body);
                                        if (resData.campaignId) {
                                            let tmp = [];
                                            let options = {
                                                'method': 'PUT',
                                                'url': apiUrl + 'partnerCampaign/' + resData.campaignId + '/sharing/' + provider[0].username,
                                                'headers': {
                                                    'Content-Type': 'application/json',
                                                    'Authorization': 'Basic ' + authKey
                                                }
                                            };
                                            request(options, (error, response, body) => {
                                                let partnerCampaign = JSON.parse(response.body);
                                                if (response.body) {
                                                    Object.entries(resData.mnoMetadata).forEach((ele) => {
                                                        let t = ele[1];
                                                        t["class"] = ele[0];
                                                        tmp.push(t);
                                                    });
                                                    let campaignData1 = tmp;
                                                    let tmpqurty = "INSERT INTO `campaign` (`iduser`,`idbrand`,`campaign_key`, `campaign_class`, `campaign_name`, `minMsgSamples`,`mno`, `mnoReview`, `mnoSupport`, `msgClass`, `noEmbeddedLink`, `noEmbeddedPhone`,`qualify`,`reqSubscriberHelp`, `reqSubscriberOptin`, `reqSubscriberOptout`, `surcharge`, `tpn`, `brandTier`, `campaign_description`, `downstreamCnpId`, `upstreamCnpId`, `sharingStatus`, `sharedDate`, `statusDate`) VALUES ";
                                                    campaignData1.forEach((campaignData) => {
                                                        tmpqurty += "('" + sessdata.iduser + "','" + campData.brandId + "', '" + resData.campaignId + "', '" + campaignData.class + "', '" + campData.campaignName + "', '" + campaignData.minMsgSamples + "', '" + campaignData.mno + "', '" + campaignData.mnoReview + "', '" + campaignData.mnoSupport + "', '" + campaignData.msgClass + "', '" + campaignData.noEmbeddedLink + "', '" + campaignData.noEmbeddedPhone + "', '" + campaignData.qualify + "', '" + campaignData.reqSubscriberHelp + "', '" + campaignData.reqSubscriberOptin + "', '" + campaignData.reqSubscriberOptin + "', '" + campaignData.surcharge + "', '" + campaignData.tpn + "', '" + campaignData.brandTier + "', '" + campData.description + "', '" + partnerCampaign.downstreamCnpId + "', '" + partnerCampaign.upstreamCnpId + "', '" + partnerCampaign.sharingStatus + "', '" + partnerCampaign.sharedDate + "', '" + partnerCampaign.statusDate + "'),";
                                                    });
                                                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = tmpqurty.slice(0, -1);
                                                    obj.prepare();
                                                    obj.execute((_error, data) => {
                                                        if (_error == 1) {
                                                            console.log(campData);
                                                            if (campData.rate) {
                                                                obj.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + CRate + " WHERE `idaccount`='" + sessdata.idaccount + "'";
                                                                obj.prepare();
                                                                obj.execute((__error, resp) => {
                                                                    if (__error == 1) {
                                                                        let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                                        iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                                                                        iQry += "`amount`='-" + CRate + "', ";
                                                                        iQry += "`purpose`='Wallet amount successfully updated for campaign registration', ";
                                                                        iQry += "`status`=1;";
                                                                        let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        objWL.nonqrysql = iQry;
                                                                        objWL.prepare();
                                                                        objWL.execute((error, result) => {
                                                                            console.log("Transaction response::", result);
                                                                        });
                                                                        let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        obj3.nonqrysql = "INSERT INTO `brand_log` (`idaccount`, `iduser`, `campaign_key`,`cost`, `date`, `description`) VALUES ('" + sessdata.idaccount + "', '" + sessdata.iduser + "', '" + resData.campaignId + "', '" + campData.rate + "', '" + Date.now() + "', 'Campaign_Rate')";
                                                                        obj3.prepare();
                                                                        obj3.execute((___error, resp) => {
                                                                            if (___error == 1) {
                                                                                let objv = new RawView_1.RawView(res);
                                                                                objv.prepare({ status: 201, message: "Campaign Register Successfully!", campaignId: resData.campaignId });
                                                                                objv.execute();
                                                                            }
                                                                            else {
                                                                                let objv = new RawView_1.RawView(res);
                                                                                objv.prepare({ status: 502, message: "Something Went Wrong With Connection!", campaignId: resData.campaignId });
                                                                                objv.execute();
                                                                            }
                                                                        });
                                                                    }
                                                                    else {
                                                                        let objv = new RawView_1.RawView(res);
                                                                        objv.prepare({ status: 502, message: "Something Went Wrong With Connection!", campaignId: resData.campaignId });
                                                                        objv.execute();
                                                                    }
                                                                });
                                                            }
                                                            else {
                                                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                                obj2.qrysql = "SELECT * From `campaign_cases` WHERE `name`='" + campData.usecase + "'";
                                                                obj2.prepare();
                                                                obj2.execute((campError, camp) => {
                                                                    if (campError == 1) {
                                                                        let CRate = typeof camp[0].rate != 'undefined' && camp[0].rate > 0 ? camp[0].rate : 0;
                                                                        obj.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + CRate + " WHERE `idaccount`='" + sessdata.idaccount + "'";
                                                                        obj.prepare();
                                                                        obj.execute((__error, resp) => {
                                                                            if (__error == 1) {
                                                                                let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                                                iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                                                                                iQry += "`amount`='-" + CRate + "', ";
                                                                                iQry += "`purpose`='Wallet amount successfully updated for campaign registration', ";
                                                                                iQry += "`status`=1;";
                                                                                let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                                objWL.nonqrysql = iQry;
                                                                                objWL.prepare();
                                                                                objWL.execute((error, result) => {
                                                                                    console.log("Transaction response::", result);
                                                                                });
                                                                                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                                obj3.nonqrysql = "INSERT INTO `brand_log` (`idaccount`, `iduser`,`campaign_key`,`cost`, `date`, `description`) VALUES ('" + sessdata.idaccount + "', '" + sessdata.iduser + "','" + resData.campaignId + "', '" + camp[0].rate + "', '" + Date.now() + "', 'Campaign_Rate')";
                                                                                obj3.prepare();
                                                                                obj3.execute((___error, resp) => {
                                                                                    if (___error == 1) {
                                                                                        let objv = new RawView_1.RawView(res);
                                                                                        objv.prepare({ status: 201, message: "Campaign Register Successfully!", campaignId: resData.campaignId });
                                                                                        objv.execute();
                                                                                    }
                                                                                    else {
                                                                                        let objv = new RawView_1.RawView(res);
                                                                                        objv.prepare({ status: 502, message: "Something Went Wrong With Connection!", campaignId: resData.campaignId });
                                                                                        objv.execute();
                                                                                    }
                                                                                });
                                                                            }
                                                                            else {
                                                                                let objv = new RawView_1.RawView(res);
                                                                                objv.prepare({ status: 502, message: "Something Went Wrong With Connection!", campaignId: resData.campaignId });
                                                                                objv.execute();
                                                                            }
                                                                        });
                                                                    }
                                                                    else {
                                                                        let objv = new RawView_1.RawView(res);
                                                                        objv.prepare({ status: 502, message: "Something Went Wrong With Connection!", campaignId: resData.campaignId });
                                                                        objv.execute();
                                                                    }
                                                                });
                                                            }
                                                        }
                                                        else {
                                                            objv.prepare({
                                                                message: "Something Went Wrong With Conection!",
                                                                error: error,
                                                                status: 502
                                                            });
                                                            objv.execute();
                                                        }
                                                    });
                                                }
                                                else {
                                                    objv.prepare({
                                                        message: "Something Went Wrong With Connection!",
                                                        error: error,
                                                        status: 502
                                                    });
                                                    objv.execute();
                                                }
                                            });
                                        }
                                        else {
                                            objv.prepare({
                                                message: resData[0].field + " " + resData[0].description,
                                                error: "Campaign did not registered!",
                                                status: 502
                                            });
                                            objv.execute();
                                        }
                                    }
                                    else {
                                        objv.prepare({
                                            message: "Something Went Wrong With Connection!",
                                            error: error,
                                            status: 502
                                        });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                objv.prepare({
                                    err: 401,
                                    message: "brandId is mendatory field!",
                                    status: 502
                                });
                                objv.execute();
                            }
                        }
                        else {
                            let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                            iQry += "`idaccount`=" + sessdata.idaccount + ", ";
                            iQry += "`amount`='-" + CRate + "', ";
                            iQry += "`purpose`='Billing prorate should be greater then 0 to register a campaign', ";
                            iQry += "`status`=2;";
                            let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                            objWL.nonqrysql = iQry;
                            objWL.prepare();
                            objWL.execute((error, result) => {
                                console.log("Transaction response::", result);
                            });
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                status: 502,
                                message: "Billing prorate should be greater then 0 to register a campaign!",
                                error: ""
                            });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            status: 502,
                            message: "Service Profile not found!",
                            error: proerr,
                            campaignId: null
                        });
                        objv.execute();
                    }
                });
            }
        });
    }
    updateCSPID(req, res, next) {
        let sdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((sessErr, sessdata) => {
            console.log('ssdata', sessdata);
            if (sessErr == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "UPDATE `account` SET `csp_id`= '" + sdata.csp_id + "' WHERE idaccount= '" + sessdata.idaccount + "'";
                obj.prepare();
                obj.execute((error, result) => {
                    if (error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: " CSP ID Updated Successfully", data: result, status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Invalid Session trying to access", status: 401 });
                objv.execute();
            }
        });
    }
    getCspId(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((sessErr, sessData) => {
            if (sessErr == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT `csp_id` FROM `account` WHERE idaccount='" + sessData.idaccount + "'";
                obj.prepare();
                obj.execute((err, result) => {
                    if (err == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: 'CSP ID Fatched', data: result, status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Invalid Authorization!", status: 401 });
                objv.execute();
            }
        });
    }
}
exports.Campaign = Campaign;
