"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sms = void 0;
const RawView_1 = require("../lib/view/RawView");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const Session_1 = require("../lib/model/Session");
const _406_1 = require("../lib/view/406");
const AppRoute_1 = require("../lib/AppRoute");
const RawQuery_1 = require("../lib/model/RawQuery");
const SinchSMS_1 = require("./SinchSMS");
const TeleApiSMS_1 = require("./TeleApiSMS");
const InteliquentSMS_1 = require("./InteliquentSMS");
const lrnApi_1 = require("./lrnApi");
var request = require("request");
var key = "30b32113d0eb4ec9984d9042a49171c6";
class Sms extends AppRoute_1.AppRoute {
    constructor() {
        super();
    }
    SendSms(req, res, next) {
        let data = req.body;
        if (data.FROM !== undefined && data.TO !== undefined && data.BODY) {
            let sdata = [];
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                if (error == 1) {
                    let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                    obj5.qrysql = "SELECT * FROM `wallet` WHERE `idaccount`='" + sessdata.idaccount + "' AND `balance` + `credit_limit` >= 0";
                    obj5.prepare();
                    obj5.execute((walletError, wallet) => {
                        if (walletError == 1) {
                            if (wallet.length > 0) {
                                let lergLogin = new lrnApi_1.LergApi("", "");
                                lergLogin.signIn(req, res, (auth_err, auth_details) => {
                                    if (auth_details !== undefined) {
                                        let auth_token = auth_details.auth_token;
                                        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                                        obj1.qrysql = "SELECT `sms_provider` FROM `did_buy` WHERE iduser='" + sessdata.iduser + "' AND `did`='" + data.FROM + "'";
                                        obj1.prepare();
                                        obj1.execute((error, responce) => {
                                            if (responce.length > 0) {
                                                let sms;
                                                switch (responce[0].sms_provider) {
                                                    case 'teleapi':
                                                        sms = new TeleApiSMS_1.TeleSMS();
                                                        sms.SendSms(req, res, next, auth_token, "teleapi", (error, resp) => {
                                                            if (resp) {
                                                                let obj1 = new RawView_1.RawView(res);
                                                                obj1.prepare({ message: "SMS Send Successfully", "result": resp, status: 201 });
                                                                obj1.execute();
                                                            }
                                                            else {
                                                                let obj = new RawView_1.RawView(res);
                                                                obj.prepare({ message: "Somthing went Wrong", "result": error, status: 502 });
                                                                obj.execute();
                                                            }
                                                        });
                                                        break;
                                                    case 'sinch':
                                                        sms = new SinchSMS_1.SinchSMS();
                                                        sms.SendSms(req, res, next, auth_token, "sinch", (error, resp) => {
                                                            if (resp) {
                                                                let obj1 = new RawView_1.RawView(res);
                                                                obj1.prepare({ message: "SMS Send Successfully", "result": resp, status: 201 });
                                                                obj1.execute();
                                                            }
                                                            else {
                                                                let obj = new RawView_1.RawView(res);
                                                                obj.prepare({ message: "Somthing went Wrong", "result": error, status: 502 });
                                                                obj.execute();
                                                            }
                                                        });
                                                        break;
                                                    case 'Inteliquent':
                                                        sms = new InteliquentSMS_1.InteliquentSMS();
                                                        sms.SendSms(req, res, next, auth_token, "inteliquent", (error, resp) => {
                                                            if (resp) {
                                                                let obj1 = new RawView_1.RawView(res);
                                                                obj1.prepare({ message: "SMS Send Successfully", "result": resp, status: 201 });
                                                                obj1.execute();
                                                            }
                                                            else {
                                                                let obj = new RawView_1.RawView(res);
                                                                obj.prepare({ message: "Somthing went Wrong", "result": error, status: 502 });
                                                                obj.execute();
                                                            }
                                                        });
                                                        break;
                                                    case 'syniverse':
                                                        sms = new SinchSMS_1.SinchSMS();
                                                        sms.SendSms(req, res, next, auth_token, "synverse4", (error, resp) => {
                                                            if (resp) {
                                                                let obj1 = new RawView_1.RawView(res);
                                                                obj1.prepare({ message: "SMS Send Successfully", "result": resp, status: 201 });
                                                                obj1.execute();
                                                            }
                                                            else {
                                                                let obj = new RawView_1.RawView(res);
                                                                obj.prepare({ message: "Somthing went Wrong", "result": error, status: 502 });
                                                                obj.execute();
                                                            }
                                                        });
                                                        break;
                                                    default:
                                                        console.log("CASE::Default");
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ message: "Invalid Account Setting", status: 502 });
                                                        objv.execute();
                                                        break;
                                                }
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ message: "Invalid Account Setting", status: 502 });
                                                objv.execute();
                                            }
                                        });
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ error: wallet, message: "Please add funds to your account or contact support.", status: 503 });
                                objv.execute();
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ error: wallet, message: "Something Went Wrong to Fetch Account Balance!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare("No session data there");
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({ message: 'All Fields are Required,FROM ,TO, BODY' });
            objv.execute();
        }
    }
    SendMms(req, res, next) {
        let data = req.body;
        if (data.FROM !== undefined && data.TO !== undefined && data.BODY && data.ATTCHMENT !== undefined) {
            let sdata = [];
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                if (error == 1) {
                    let lergLogin = new lrnApi_1.LergApi("", "");
                    lergLogin.signIn(req, res, (auth_err, auth_details) => {
                        if (auth_details) {
                            console.log("auth_details", auth_details);
                            let auth_token = auth_details.auth_token;
                            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                            obj1.qrysql = "SELECT p.`priority` ,u.`username` FROM preference p LEFT JOIN `user` u ON p.idsupplier=u.idaccount WHERE p.idservice=(SELECT idservice FROM `user` WHERE iduser = '" + sessdata.iduser + "' ) AND p.type='sms'";
                            obj1.prepare();
                            obj1.execute((error, responce) => {
                                if (responce.length > 0) {
                                    let tmp = responce;
                                    sdata["type"] = tmp[0].username;
                                    let sms;
                                    switch (sdata.type) {
                                        case 'teleapi':
                                            sms = new TeleApiSMS_1.TeleSMS();
                                            sms.SendMms(req, res, next, auth_token, "teleapi", (error, resp) => {
                                                if (resp) {
                                                    let obj1 = new RawView_1.RawView(res);
                                                    obj1.prepare({ "message": "SMS Send Successfully", "result": resp });
                                                    obj1.execute();
                                                }
                                                else {
                                                    let obj = new RawView_1.RawView(res);
                                                    obj.prepare({ "message": "Somthing went Wrong", "result": error });
                                                    obj.execute();
                                                }
                                            });
                                            break;
                                        case 'Sinch':
                                            sms = new SinchSMS_1.SinchSMS();
                                            sms.SendMms(req, res, next, auth_token, "sinch", (error, resp) => {
                                                if (resp) {
                                                    let obj1 = new RawView_1.RawView(res);
                                                    obj1.prepare({ "message": "SMS Send Successfully", "result": resp });
                                                    obj1.execute();
                                                }
                                                else {
                                                    let obj = new RawView_1.RawView(res);
                                                    obj.prepare({ "message": "Somthing went Wrong", "result": error });
                                                    obj.execute();
                                                }
                                            });
                                            break;
                                        case 'Inteliquent':
                                            sms = new InteliquentSMS_1.InteliquentSMS();
                                            sms.SendSms(req, res, next, auth_token, "inteliquent", (error, resp) => {
                                                if (resp) {
                                                    let obj1 = new RawView_1.RawView(res);
                                                    obj1.prepare({ "message": "SMS Send Successfully", "result": resp });
                                                    obj1.execute();
                                                }
                                                else {
                                                    let obj = new RawView_1.RawView(res);
                                                    obj.prepare({ "message": "Somthing went Wrong", "result": error });
                                                    obj.execute();
                                                }
                                            });
                                            break;
                                    }
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ message: "Invalid  Setting" });
                                    objv.execute();
                                }
                            });
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare("No session data there");
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({ message: 'All Fields are Required,FROM ,TO, BODY, ATTCHMENT' });
            objv.execute();
        }
    }
    mdrsearch(req, res, next) {
        console.log("Req==>" + JSON.stringify(req.body));
        var sdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var options = {
                    'method': 'GET',
                    'url': 'https://sms.api.sinch.com/xms/v1/IPLink_gw111/batches/' + `${sdata.Batch_Id}` + '/delivery_report/' + `${sdata.Recipient_id}`,
                    'headers': {
                        'Authorization': "Bearer " + key,
                        'Content-Type': 'application/json'
                    }
                };
                request(options, function (error, response) {
                    if (error) {
                        let obj = new RawView_1.RawView(res);
                        obj.prepare({ "message": error });
                        obj.execute();
                    }
                    else {
                        console.log("Body==>", response.body);
                        var smsdetails = JSON.parse(response.body);
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "UPDATE `mdr` SET `status`='" + smsdetails.status + "' , `deliver_at`='" + smsdetails.at + "' , `operator_status_at`='" + smsdetails.operator_status_at + "' WHERE `batch_id`='" + sdata.Batch_Id + "' AND `idaccount`='" + sessdata.idaccount + "'";
                        obj.prepare();
                        obj.execute((error, responce) => {
                            if (responce) {
                                let obj = new RawQuery_1.ModelRawQuery(req, res);
                                obj.qrysql = "SELECT * FROM `mdr` WHERE `batch_id`='" + sdata.Batch_Id + "' AND `idaccount`='" + sessdata.idaccount + "'";
                                obj.prepare();
                                obj.execute((err, resp) => {
                                    let obj1 = new RawView_1.RawView(res);
                                    obj1.prepare({ "message": "Sms Details", "result": resp });
                                    obj1.execute();
                                });
                            }
                            else {
                                let obj = new RawView_1.RawView(res);
                                obj.prepare({ "message": error });
                                obj.execute();
                            }
                        });
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
}
exports.Sms = Sms;
