'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignUPLogin = void 0;
const module_config_1 = require("../config/module.config");
const ModelLogin_1 = require("./model/ModelLogin");
const Session_1 = require("./model/Session");
const RawView_1 = require("./view/RawView");
const _403_1 = require("./view/403");
const RawNonQuery_1 = require("./model/RawNonQuery");
const server_1 = require("../server");
class SignUPLogin {
    sessdata;
    constructor() { }
    SignUPLogin(req, res, next) {
        let validationKey = req.body.key;
        let isEmailVerify = req.body.isEmailVerify;
        req.body = { validationKey: validationKey, isEmailVerify: isEmailVerify, isMobileVerfy: false };
        let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
        obj3.nonqrysql = "UPDATE `user` SET `isEmailVerify`='" + isEmailVerify + "' WHERE `validationKey`='" + validationKey + "'";
        obj3.prepare();
        obj3.execute((_err, __result) => {
            if (_err == 1) {
                let obj = new ModelLogin_1.ModelLogin(req, res);
                let modEmail = new module_config_1.modEmailVerify();
                if (obj.prepare(modEmail)) {
                    obj.execute((error, result) => {
                        if (error == 2) {
                            let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                            obj5.nonqrysql = "SELECT iduser FROM `user` WHERE `validationKey`='" + validationKey + "'";
                            obj5.prepare();
                            obj5.execute((__error, user) => {
                                if (__error == 1) {
                                    let obj4 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    obj4.nonqrysql = "UPDATE `session` SET `isEmailVerify`='" + isEmailVerify + "' WHERE `iduser`='" + user[0].iduser + "'";
                                    obj4.prepare();
                                    obj4.execute((__err, __result) => {
                                        if (__err == 1) {
                                            server_1.sessiondata.set(user[0].iduser, result);
                                            let session = new Session_1.SessionManagment(req, res, next);
                                            session.SetSession(result, (error, sessdata) => {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ session: result.authkey, type: "email", data: result, status: 201 });
                                                objv.execute();
                                            });
                                        }
                                        else {
                                            result;
                                            let objv = new _403_1.Res403(res);
                                            objv.prepare({ message: "Database Connection Break", status: 401 });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let objv = new _403_1.Res403(res);
                                    objv.prepare({ message: "Database Connection Break", status: 401 });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv = new _403_1.Res403(res);
                            objv.prepare({ message: "Invalid User to set proper session!", status: 401 });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new _403_1.Res403(res);
                    objv.prepare({ message: "Opps Something went wrong with Connection!", status: 502 });
                    objv.execute();
                }
            }
        });
    }
}
exports.SignUPLogin = SignUPLogin;
